#include <windows.h>
#include <windowsx.h>
#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include "numerics.h"
#include "globals.h"
#include "structs.h"
extern HWND mainwnd;
#define PARAM 1
#define IC 2

#define MB(a) MessageBox(mainwnd,a,"",MB_OK)
extern struct {
  char item[30];
  int steps,side,cycle,movie,index;
  double plow,phigh;
} shoot_range;
extern struct {
         char item[30],item2[30];
         int steps,reset,oldic,index,index2,cycle,type,type2,movie;
         double plow,phigh;
         double plow2,phigh2;
         int rtype;
       } range;

 

extern struct {
         char item[30];
         int steps,shoot,col,movie,index;
         double plow,phigh;
       } eq_range;
extern char uvar_names[MAXODE][12];
extern char upar_names[200][11];
extern int NEQ,NODE,NMarkov,NUPAR;
extern int RANGE_FLAG,FPRANGE_FLAG,BVPRANGE_FLAG;
extern GRAPH *MyGraph;
/*   this does all the numerics dialogs  */
double atof();
typedef struct {
    int nmodes,col;
} FOURIER_PAR;

extern FOURIER_PAR four_par;

typedef struct {
    int bins,col;
    char cond[256];
    double zlo,zhi;
} HISTOGRAM_PAR;

extern HISTOGRAM_PAR hist_par;



BOOL CALLBACK HistDialogFunc(HWND hdwnd ,UINT message ,WPARAM wparam ,LPARAM lparam )
{
 int i;   
switch(message){
         case WM_INITDIALOG:
         SendDlgItemMessage( hdwnd,IDHIST_VAR,LB_ADDSTRING,0,(LPARAM)"t");
         for(i=0;i<NEQ;i++)
           SendDlgItemMessage( hdwnd,IDHIST_VAR,LB_ADDSTRING,0,
           (LPARAM)uvar_names[i]);
          SendDlgItemMessage(hdwnd,IDHIST_VAR,LB_SETCURSEL,hist_par.col,0);
          set_vi(hdwnd,IDHIST_BINS,hist_par.bins);
          set_vd(hdwnd,IDHIST_ZLO,hist_par.zlo);
          set_vd(hdwnd,IDHIST_ZHI,hist_par.zhi);
           SetDlgItemText(hdwnd,IDHIST_COND,hist_par.cond);
           
         return 1;
         case WM_COMMAND:
                switch(LOWORD(wparam)){
                 case IDOK:
                 i=SendDlgItemMessage(hdwnd,IDHIST_VAR,LB_GETCURSEL,
                 0,0L);
                 if(i>=0)hist_par.col=i;
                 get_vi(hdwnd,IDHIST_BINS,&hist_par.bins);
                 get_vd(hdwnd,IDHIST_ZLO,&hist_par.zlo);
                  get_vd(hdwnd,IDHIST_ZHI,&hist_par.zhi);
                   GetDlgItemText(hdwnd,IDHIST_COND,hist_par.cond,250);
                  EndDialog(hdwnd,0);
                  new_hist(hist_par.bins,hist_par.zlo,
                  hist_par.zhi,hist_par.col,hist_par.cond);
                 break;
                 case IDCANCEL:
                 EndDialog(hdwnd,0);
                 break;
                }
                return 1;
}
return 0;
}
                
               
 
BOOL CALLBACK FourierDialogFunc(HWND hdwnd ,UINT message ,WPARAM wparam ,LPARAM lparam )
{
    int i;
switch(message){
         case WM_INITDIALOG:

         SendDlgItemMessage( hdwnd,IDFOUR_VAR,LB_ADDSTRING,0,(LPARAM)"t");
         for(i=0;i<NEQ;i++)
           SendDlgItemMessage( hdwnd,IDFOUR_VAR,LB_ADDSTRING,0,
           (LPARAM)uvar_names[i]);
          SendDlgItemMessage(hdwnd,IDFOUR_VAR,LB_SETCURSEL,four_par.col,0);
          set_vi(hdwnd,IDFOUR_NMODES,four_par.nmodes);
         return 1;
         case WM_COMMAND:
                switch(LOWORD(wparam)){
                 case IDOK:
                  i=SendDlgItemMessage(hdwnd,IDFOUR_VAR,LB_GETCURSEL,
                 0,0L);
                 if(i>=0)four_par.col=i;
                 get_vi(hdwnd,IDFOUR_NMODES,&four_par.nmodes);
                  EndDialog(hdwnd,0);
                  new_four(four_par.nmodes,four_par.col);
                 break;
                 case IDCANCEL:
                 EndDialog(hdwnd,0);
                 break;
                }
                return 1;
}
 return 0;
}


/* interface for BVP range stuff */
BOOL CALLBACK BvpRangeDialogFunc(HWND hdwnd ,UINT message ,WPARAM wparam ,LPARAM lparam )
{
char bob[256];
 int i,j;
 switch(message){
         case WM_INITDIALOG:
         BVPRANGE_FLAG=0;
        
         for(i=0;i<NUPAR;i++)
            SendDlgItemMessage(hdwnd,IDVARY_BV,LB_ADDSTRING,0,(LPARAM)upar_names[i]);
  
         sprintf(bob,"%g",shoot_range.plow);
         SetDlgItemText(hdwnd,IDFROM_BV,bob);
           sprintf(bob,"%g",shoot_range.phigh);
         SetDlgItemText(hdwnd,IDTO_BV,bob);
         SetDlgItemInt(hdwnd,IDSTEPS_BV,shoot_range.steps,FALSE);
         if(shoot_range.index>=0)
              SendDlgItemMessage(hdwnd,IDVARY_BV,LB_SETCURSEL,shoot_range.index,0L);
         SendDlgItemMessage(hdwnd,IDCYCLE_BV,BM_SETCHECK,shoot_range.cycle,0L);     
         if(shoot_range.side==0){
           SendDlgItemMessage(hdwnd,IDLEFT_BV,BM_SETCHECK,1,0L);     
           SendDlgItemMessage(hdwnd,IDRIGHT_BV,BM_SETCHECK,0,0L);
         }
         else {
             SendDlgItemMessage(hdwnd,IDLEFT_BV,BM_SETCHECK,0,0L);     
           SendDlgItemMessage(hdwnd,IDRIGHT_BV,BM_SETCHECK,1,0L);
         }
         return 1;
          case WM_COMMAND:
                switch(LOWORD(wparam)){
                 case IDCANCEL:
                      EndDialog(hdwnd,0);
                      return 1;
                 case IDOK:

                 i=SendDlgItemMessage(hdwnd,IDVARY_BV,LB_GETCURSEL,0,0L);
                      if(i>=0){
                          
                            
                              shoot_range.index=i;
                              strcpy(shoot_range.item,upar_names[i]);
                          
                      
                          GetDlgItemText(hdwnd,IDFROM_BV,bob,250);
                          shoot_range.plow=atof(bob);
                          GetDlgItemText(hdwnd,IDTO_BV,bob,250);
                          shoot_range.phigh=atof(bob);
                          GetDlgItemText(hdwnd,IDSTEPS_BV,bob,250);
                          shoot_range.steps=atoi(bob);
                           if(shoot_range.steps<=0)shoot_range.steps=10;
                          shoot_range.cycle=SendDlgItemMessage(hdwnd,IDCYCLE_BV,BM_GETCHECK,0,0L);
                          i=SendDlgItemMessage(hdwnd,IDLEFT_BV,BM_GETCHECK,0,0L);
                          if(i==1)shoot_range.side=0;
                          else shoot_range.side=1;
                          
                           BVPRANGE_FLAG=1;
                           EndDialog(hdwnd,0);
                           return 1;
                      }
                        else {
                            err_msg("Please click on parameter to vary first");
                           
                            return 1;
                        }                        
                      
                }

 }
 return 0;
}
          
   
BOOL CALLBACK EqRangeDialogFunc(HWND hdwnd ,UINT message ,WPARAM wparam ,LPARAM lparam )
{
char bob[256];
 int i,j;
 switch(message){
         case WM_INITDIALOG:
         FPRANGE_FLAG=0;
        
         for(i=0;i<NUPAR;i++)
            SendDlgItemMessage(hdwnd,IDVARY_RF,CB_ADDSTRING,0,(LPARAM)upar_names[i]);
          SendDlgItemMessage(hdwnd,IDSTAB_RF,CB_ADDSTRING,0,(LPARAM)"none");
          SendDlgItemMessage(hdwnd,IDSTAB_RF,CB_ADDSTRING,0,(LPARAM)"Time");
          for(i=0;i<NEQ;i++)
           SendDlgItemMessage(hdwnd,IDSTAB_RF,CB_ADDSTRING,0,(LPARAM)uvar_names[i]);  
         sprintf(bob,"%g",eq_range.plow);
         SetDlgItemText(hdwnd,IDFROM_RF,bob);
           sprintf(bob,"%g",eq_range.phigh);
         SetDlgItemText(hdwnd,IDTO_RF,bob);
         SetDlgItemInt(hdwnd,IDSTEPS_RF,eq_range.steps,FALSE);
        
      
             if(eq_range.index>=0)
              SendDlgItemMessage(hdwnd,IDVARY_RF,CB_SETCURSEL,eq_range.index,0L);
         
         SendDlgItemMessage(hdwnd,IDSHOOT_RF,BM_SETCHECK,eq_range.shoot,0L);
            if(eq_range.col>=1&&eq_range.col<=NEQ)
             SendDlgItemMessage(hdwnd,IDSTAB_RF,CB_SETCURSEL,eq_range.col,0L);
            else
              SendDlgItemMessage(hdwnd,IDSTAB_RF,CB_SETCURSEL,0,0L);        
          return 1;
          case WM_COMMAND:
                switch(LOWORD(wparam)){
                    case IDOKAY_RF:
                      i=SendDlgItemMessage(hdwnd,IDVARY_RF,CB_GETCURSEL,0,0L);
                      if(i>=0){
                          
                            
                              eq_range.index=i;
                              strcpy(eq_range.item,upar_names[i]);
                          
                      
                          GetDlgItemText(hdwnd,IDFROM_RF,bob,250);
                          eq_range.plow=atof(bob);
                          GetDlgItemText(hdwnd,IDTO_RF,bob,250);
                          eq_range.phigh=atof(bob);
                          GetDlgItemText(hdwnd,IDSTEPS_RF,bob,250);
                          eq_range.steps=atoi(bob);
                           if(eq_range.steps<=0)eq_range.steps=10;
                          eq_range.shoot=SendDlgItemMessage(hdwnd,IDSHOOT_RF,BM_GETCHECK,0,0L);
                          j=SendDlgItemMessage(hdwnd,IDSTAB_RF,CB_GETCURSEL,0,0L);
                          if(j>=0){
                              if(j==0)eq_range.col=-1;
                              else eq_range.col=j;
                          }
                           FPRANGE_FLAG=1;
                           EndDialog(hdwnd,0);
                           return 1;
                      }
                        else {
                            err_msg("Please click on parameter to vary first");
                            return 1;
                        }                        
                case IDCANCEL_RI:
                        FPRANGE_FLAG=0;
                        EndDialog(hdwnd,0);
                        return 1;
                }
 }
 return 0;               
            

}


/*  interface for filling 2range stuff */
BOOL CALLBACK Range2DialogFunc(HWND hdwnd ,UINT message ,WPARAM wparam ,LPARAM lparam )
{
    char bob[256];
 int i;
 int n1=NODE+NMarkov;
 switch(message){
         case WM_INITDIALOG:
         RANGE_FLAG=0;
         for(i=0;i<n1;i++)
            SendDlgItemMessage(hdwnd,IDVARY1_R2,LB_ADDSTRING,0,(LPARAM)uvar_names[i]);
         for(i=0;i<NUPAR;i++)
            SendDlgItemMessage(hdwnd,IDVARY1_R2,LB_ADDSTRING,0,(LPARAM)upar_names[i]);
           for(i=0;i<n1;i++)
            SendDlgItemMessage(hdwnd,IDVARY2_R2,LB_ADDSTRING,0,(LPARAM)uvar_names[i]);
         for(i=0;i<NUPAR;i++)
            SendDlgItemMessage(hdwnd,IDVARY2_R2,LB_ADDSTRING,0,(LPARAM)upar_names[i]);
 
         sprintf(bob,"%g",range.plow);
         SetDlgItemText(hdwnd,IDFROM1_R2,bob);
           sprintf(bob,"%g",range.phigh);
         SetDlgItemText(hdwnd,IDTO1_R2,bob);
         
         sprintf(bob,"%g",range.plow2);
         SetDlgItemText(hdwnd,IDFROM2_R2,bob);
           sprintf(bob,"%g",range.phigh2);
         SetDlgItemText(hdwnd,IDTO2_R2,bob);
         SetDlgItemInt(hdwnd,IDSTEPS_R2,range.steps,FALSE);
         if(range.type==IC){
             if(range.index>=0)
              SendDlgItemMessage(hdwnd,IDVARY1_R2,LB_SETCURSEL,range.index,0L);
         }
         if(range.type==PARAM){
             if(range.index>=0)
              SendDlgItemMessage(hdwnd,IDVARY1_R2,LB_SETCURSEL,range.index+n1,0L);
         }

         if(range.type2==IC){
             if(range.index2>=0)
              SendDlgItemMessage(hdwnd,IDVARY2_R2,LB_SETCURSEL,range.index2,0L);
         }
         if(range.type2==PARAM){
             if(range.index2>=0)
              SendDlgItemMessage(hdwnd,IDVARY2_R2,LB_SETCURSEL,range.index2+n1,0L);
         }
         
         SendDlgItemMessage(hdwnd,IDRESET_R2,BM_SETCHECK,range.reset,0L);
         SendDlgItemMessage(hdwnd,IDCYCLE_R2,BM_SETCHECK,range.cycle,0L);
          SendDlgItemMessage(hdwnd,IDOLDIC_R2,BM_SETCHECK,range.oldic,0L);
          if(range.rtype==2){
              SendDlgItemMessage(hdwnd,IDARRAY_R2,BM_SETCHECK,1,0L);
         SendDlgItemMessage(hdwnd,IDCURVE_R2,BM_SETCHECK,0,0L);
          }
          else {
                   SendDlgItemMessage(hdwnd,IDARRAY_R2,BM_SETCHECK,0,0L);
         SendDlgItemMessage(hdwnd,IDCURVE_R2,BM_SETCHECK,1,0L);
          }
              
          return 1;
case WM_COMMAND:
                switch(LOWORD(wparam)){
                    case IDOK:
                      i=SendDlgItemMessage(hdwnd,IDVARY1_R2,LB_GETCURSEL,0,0L);
                      if(i>=0){
                          if(i<n1){
                              range.type=IC;
                              range.index=i;
                              strcpy(range.item,uvar_names[i]);
                          }
                          if(i>=n1){
                              range.type=PARAM;
                              range.index=i-n1;
                              strcpy(range.item,upar_names[i-n1]);
                          }
                      }
                       i=SendDlgItemMessage(hdwnd,IDVARY2_R2,LB_GETCURSEL,0,0L);
                      if(i>=0){
                          if(i<n1){
                              range.type2=IC;
                              range.index2=i;
                              strcpy(range.item2,uvar_names[i]);
                          }
                          if(i>=n1){
                              range.type2=PARAM;
                              range.index2=i-n1;
                              strcpy(range.item2,upar_names[i-n1]);
                          }
                      }
                          GetDlgItemText(hdwnd,IDFROM1_R2,bob,250);
                          range.plow=atof(bob);
                          GetDlgItemText(hdwnd,IDTO1_R2,bob,250);
                          range.phigh=atof(bob);

                          GetDlgItemText(hdwnd,IDFROM2_R2,bob,250);
                          range.plow2=atof(bob);
                          GetDlgItemText(hdwnd,IDTO2_R2,bob,250);
                          range.phigh2=atof(bob);
                          
                          GetDlgItemText(hdwnd,IDSTEPS_R2,bob,250);
                          range.steps=atoi(bob);
                           if(range.steps<=0)range.steps=10;
                          range.oldic=SendDlgItemMessage(hdwnd,IDOLDIC_R2,BM_GETCHECK,0,0L);
                           range.reset=SendDlgItemMessage(hdwnd,IDRESET_R2,BM_GETCHECK,0,0L);
                           range.cycle=SendDlgItemMessage(hdwnd,IDCYCLE_R2,BM_GETCHECK,0,0L);
                           RANGE_FLAG=1;
                           if(SendDlgItemMessage(hdwnd,IDCURVE_R2,BM_GETCHECK,0,0L)==1)
                           range.rtype=1;
                           else
                           range.rtype=2;
                           EndDialog(hdwnd,0);
                           return 1;
                                         
                case IDCANCEL:
                        RANGE_FLAG=0;
                        EndDialog(hdwnd,0);
                        return 1;
                }
 }
 return 0;               
            

}    



/*  interface for filling range stuff */
BOOL CALLBACK IntRangeDialogFunc(HWND hdwnd ,UINT message ,WPARAM wparam ,LPARAM lparam )
{
char bob[256];
 int i;
 int n1=NODE+NMarkov;
 switch(message){
         case WM_INITDIALOG:
         RANGE_FLAG=0;
         for(i=0;i<n1;i++)
            SendDlgItemMessage(hdwnd,IDVARY_RI,CB_ADDSTRING,0,(LPARAM)uvar_names[i]);
         for(i=0;i<NUPAR;i++)
            SendDlgItemMessage(hdwnd,IDVARY_RI,CB_ADDSTRING,0,(LPARAM)upar_names[i]);
            
         sprintf(bob,"%g",range.plow);
         SetDlgItemText(hdwnd,IDFROM_RI,bob);
           sprintf(bob,"%g",range.phigh);
         SetDlgItemText(hdwnd,IDTO_RI,bob);
         SetDlgItemInt(hdwnd,IDSTEPS_RI,range.steps,FALSE);
         if(range.type==IC){
             if(range.index>=0)
              SendDlgItemMessage(hdwnd,IDVARY_RI,CB_SETCURSEL,range.index,0L);
         }
         if(range.type==PARAM){
             if(range.index>=0)
              SendDlgItemMessage(hdwnd,IDVARY_RI,CB_SETCURSEL,range.index+n1,0L);
         }
         SendDlgItemMessage(hdwnd,IDRESET_RI,BM_SETCHECK,range.reset,0L);
         SendDlgItemMessage(hdwnd,IDCYCLE_RI,BM_SETCHECK,range.cycle,0L);
          SendDlgItemMessage(hdwnd,IDOLDIC_RI,BM_SETCHECK,range.oldic,0L);
          return 1;
          case WM_COMMAND:
                switch(LOWORD(wparam)){
                    case IDOKAY_RI:
                      i=SendDlgItemMessage(hdwnd,IDVARY_RI,CB_GETCURSEL,0,0L);
                      if(i>=0){
                          if(i<n1){
                              range.type=IC;
                              range.index=i;
                              strcpy(range.item,uvar_names[i]);
                          }
                          if(i>=n1){
                              range.type=PARAM;
                              range.index=i-n1;
                              strcpy(range.item,upar_names[i-n1]);
                          }
                      
                          GetDlgItemText(hdwnd,IDFROM_RI,bob,250);
                          range.plow=atof(bob);
                          GetDlgItemText(hdwnd,IDTO_RI,bob,250);
                          range.phigh=atof(bob);
                          GetDlgItemText(hdwnd,IDSTEPS_RI,bob,250);
                          range.steps=atoi(bob);
                           if(range.steps<=0)range.steps=10;
                          range.oldic=SendDlgItemMessage(hdwnd,IDOLDIC_RI,BM_GETCHECK,0,0L);
                           range.reset=SendDlgItemMessage(hdwnd,IDRESET_RI,BM_GETCHECK,0,0L);
                           range.cycle=SendDlgItemMessage(hdwnd,IDCYCLE_RI,BM_GETCHECK,0,0L);
                           RANGE_FLAG=1;
                           range.rtype=0;
                           EndDialog(hdwnd,0);
                           return 1;
                      }
                        else {
                            err_msg("Please click on variable/parameter first");
                            return 1;
                        }                        
                case IDCANCEL_RI:
                        RANGE_FLAG=0;
                        EndDialog(hdwnd,0);
                        return 1;
                }
 }
 return 0;               
            

}    

BOOL CALLBACK RuelleDialogFunc(HWND hdwnd,UINT message,WPARAM wparam,LPARAM lparam)
{
    int i;
    switch(message){
         case WM_INITDIALOG:
                SetDlgItemInt(hdwnd,IDX_RUE,(UINT)MyGraph->xshft,FALSE);
                SetDlgItemInt(hdwnd,IDY_RUE,(UINT)MyGraph->yshft,FALSE);
                SetDlgItemInt(hdwnd,IDZ_RUE,(UINT)MyGraph->zshft,FALSE);
                return 1;
         case WM_COMMAND:
                switch(LOWORD(wparam)){
                case IDOK_RUE:
                     i=GetDlgItemInt(hdwnd,IDX_RUE,NULL,FALSE);
                     if(i>=0)MyGraph->xshft=i;
                      i=GetDlgItemInt(hdwnd,IDY_RUE,NULL,FALSE);
                     if(i>=0)MyGraph->yshft=i;
                      i=GetDlgItemInt(hdwnd,IDZ_RUE,NULL,FALSE);
                     if(i>=0)MyGraph->zshft=i;
                     EndDialog(hdwnd,0);
                     return 1;
                     
                  case IDRESET_RUE:
                SetDlgItemInt(hdwnd,IDX_RUE,(UINT)0,FALSE);
                SetDlgItemInt(hdwnd,IDY_RUE,(UINT)0,FALSE);
                SetDlgItemInt(hdwnd,IDZ_RUE,(UINT)0,FALSE);
                return 1;
                }
    }
    return 0;
}      

   
BOOL CALLBACK PoincareDialogFunc(HWND hdwnd,UINT message,WPARAM wparam,LPARAM lparam)
{
 char bob[256];
 int i;
 switch(message){
         case WM_INITDIALOG:
            SendDlgItemMessage(hdwnd,IDVAR_PMAP,CB_ADDSTRING,0,
             (LPARAM)"t");
             for(i=0;i<NEQ;i++)
              SendDlgItemMessage(hdwnd,IDVAR_PMAP,CB_ADDSTRING,0,
             (LPARAM)uvar_names[i]);
             SendDlgItemMessage(hdwnd,IDVAR_PMAP,CB_SETCURSEL,POIVAR,0L);
             SendDlgItemMessage(hdwnd,IDSOS_PMAP,BM_SETCHECK,SOS,0L);
             if(POISGN==0)
              SendDlgItemMessage(hdwnd,IDBOT_PMAP,BM_SETCHECK,1,0L);
              if(POISGN<0)
              SendDlgItemMessage(hdwnd,IDNEG_PMAP,BM_SETCHECK,1,0L);
              if(POISGN>0)
              SendDlgItemMessage(hdwnd,IDPOS_PMAP,BM_SETCHECK,1,0L);
              if(POIMAP==0)
                  SendDlgItemMessage(hdwnd,IDNON_PMAP,BM_SETCHECK,1,0L);
               if(POIMAP==1)
                  SendDlgItemMessage(hdwnd,IDSEC_PMAP,BM_SETCHECK,1,0L);
              if(POIMAP==2)
                  SendDlgItemMessage(hdwnd,IDMAX_PMAP,BM_SETCHECK,1,0L);
              if(POIMAP==3)
                  SendDlgItemMessage(hdwnd,IDPER_PMAP,BM_SETCHECK,1,0L);
               sprintf(bob,"%g",POIPLN);
                  SetDlgItemText(hdwnd,IDVAL_PMAP,bob);
                               
            return 1;
         case WM_COMMAND:
             switch(LOWORD(wparam)){
              case IDOK_PMAP:
                 if(SendDlgItemMessage(hdwnd,IDNON_PMAP,BM_GETCHECK,0,0L))
                    POIMAP=0;
                  if(SendDlgItemMessage(hdwnd,IDSEC_PMAP,BM_GETCHECK,0,0L))
                    POIMAP=1;
                   if(SendDlgItemMessage(hdwnd,IDMAX_PMAP,BM_GETCHECK,0,0L))
                    POIMAP=2;
                    if(SendDlgItemMessage(hdwnd,IDPER_PMAP,BM_GETCHECK,0,0L))
                    POIMAP=3;
                  if(SendDlgItemMessage(hdwnd,IDBOT_PMAP,BM_GETCHECK,0,0L))
                    POISGN=0;
                    if(SendDlgItemMessage(hdwnd,IDPOS_PMAP,BM_GETCHECK,0,0L))
                    POISGN=1;
                   if(SendDlgItemMessage(hdwnd,IDNEG_PMAP,BM_GETCHECK,0,0L))
                    POISGN=-1;
                   SOS=SendDlgItemMessage(hdwnd,IDSOS_PMAP,BM_GETCHECK,0,0L);
                   i=SendDlgItemMessage(hdwnd,IDVAR_PMAP,CB_GETCURSEL,0,0L);
                   if(i>=0)
                     POIVAR=i;
                   
                   GetDlgItemText(hdwnd,IDVAL_PMAP,bob,250);
                   POIPLN=atof(bob);
                   EndDialog(hdwnd,0); 
                       
                              
              return 1;
              case IDCANCEL_PMAP:
              EndDialog(hdwnd,0);
              return 1;
             }
 }
 return 0;
} 
BOOL CALLBACK PhaseDialogFunc(HWND hdwnd,UINT message,WPARAM wparam,LPARAM lparam)
 {
   char bob[256];
   int i;
     switch(message){
         case WM_INITDIALOG:
          sprintf(bob,"%d",NMESH);
            SetDlgItemText(hdwnd,IDNULL_PP,bob);
            sprintf(bob,"%d",DF_GRID);
            SetDlgItemText(hdwnd,IDDIR_PP,bob);
             sprintf(bob,"%d",FLOW_GRID);  
            SetDlgItemText(hdwnd,IDFLOW_PP,bob);
            return 1;
         case WM_COMMAND:
            switch(LOWORD(wparam)){
              case IDOK_PP:
                    GetDlgItemText(hdwnd,IDFLOW_PP,bob,250);
                    i=atoi(bob);
                    if(i>1)FLOW_GRID=i;
                      GetDlgItemText(hdwnd,IDNULL_PP,bob,250);
                    i=atoi(bob);
                    if(i>1)NMESH=i;
                     GetDlgItemText(hdwnd,IDDIR_PP,bob,250);
                    i=atoi(bob);
                    if(i>1)DF_GRID=i;
                    EndDialog(hdwnd,0);
                    return 1;
            }
     }
     return 0;

 }
BOOL CALLBACK NumCtlDialogFunc(HWND hdwnd,UINT message,WPARAM wparam,LPARAM lparam)
 {
  int i;
  double z;
  char bob[256];
    switch(message){
         case WM_INITDIALOG:
         sprintf(bob,"%g",BVP_TOL);
         SetDlgItemText(hdwnd,ID_BVPTOL,bob);
         sprintf(bob,"%g",BVP_EPS);
         SetDlgItemText(hdwnd,ID_BVPEPS,bob);
         sprintf(bob,"%g",NEWT_ERR);
         SetDlgItemText(hdwnd,ID_NEWDH,bob);
         sprintf(bob,"%g",EVEC_ERR);
         SetDlgItemText(hdwnd,ID_NEWTOL,bob);
         sprintf(bob,"%g",AlphaMax);
         SetDlgItemText(hdwnd,ID_ALPH,bob);
         sprintf(bob,"%g",OmegaMax);
         SetDlgItemText(hdwnd,ID_OMEG,bob);
         sprintf(bob,"%d",BVP_MAXIT);
         SetDlgItemText(hdwnd,ID_BVPITER,bob);
         sprintf(bob,"%d",EVEC_ITER);
         SetDlgItemText(hdwnd,ID_NEWTIT,bob);
         sprintf(bob,"%d",DelayGrid);
         SetDlgItemText(hdwnd,ID_DELIT,bob);
         return 1;
       case WM_COMMAND:
            switch(LOWORD(wparam)){
                   case ID_CAN_NC:
                   EndDialog(hdwnd,0);
                   return 1; /* do nothing */
                   case ID_OK_NC:
                   GetDlgItemText(hdwnd,ID_BVPEPS,bob,250);
                   BVP_EPS=atof(bob);   
                   GetDlgItemText(hdwnd,ID_BVPTOL,bob,250);
                   BVP_TOL=atof(bob);
                   GetDlgItemText(hdwnd,ID_NEWDH,bob,250);
                   NEWT_ERR=atof(bob);
                   GetDlgItemText(hdwnd,ID_NEWTOL,bob,250);
                   EVEC_ERR=atof(bob);
                   GetDlgItemText(hdwnd,ID_ALPH,bob,250);
                   AlphaMax=atof(bob);
                   GetDlgItemText(hdwnd,ID_OMEG,bob,250);
                   OmegaMax=atof(bob);
                   GetDlgItemText(hdwnd,ID_BVPITER,bob,250);
                   BVP_MAXIT=atoi(bob);
                   GetDlgItemText(hdwnd,ID_NEWTIT,bob,250);
                   EVEC_ITER=atoi(bob);
                   GetDlgItemText(hdwnd,ID_DELIT,bob,250);
                   DelayGrid=atoi(bob);
                       EndDialog(hdwnd,0);
                       return 1;
            }
    }
    return 0;
 }
 
BOOL CALLBACK MethDialogFunc(HWND hdwnd,UINT message,WPARAM wparam,LPARAM lparam)
 {
     int i,ick=METHOD,tmp;
     double olddt=DELTA_T,olddel=DELAY;
     char bob[256];
     switch(message){
         case WM_INITDIALOG:
          sprintf(bob,"%g",DELTA_T);
            SetDlgItemText(hdwnd,IDNUM_TIMDT,bob);
            sprintf(bob,"%g",TEND);
            SetDlgItemText(hdwnd,IDNUM_TIMTEND,bob);
             sprintf(bob,"%g",T0);  
            SetDlgItemText(hdwnd,IDNUM_TIMT0,bob);
            sprintf(bob,"%g",TRANS);
            SetDlgItemText(hdwnd,IDNUM_TIMTRANS,bob);
             sprintf(bob,"%d",NJMP);  
            SetDlgItemText(hdwnd,IDNUM_TIMNOUT,bob);
            sprintf(bob,"%g",DELAY);
            SetDlgItemText(hdwnd,IDNUM_TIMDEL,bob);
            SendDlgItemMessage(hdwnd,IDNUM_DISCRETE+METHOD,BM_SETCHECK,1,0);
            sprintf(bob,"%g",TOLER);
            SetDlgItemText(hdwnd,IDNUM_METHTOL,bob);
            sprintf(bob,"%g",ATOLER);
            SetDlgItemText(hdwnd,IDNUM_METHATOL,bob);
            sprintf(bob,"%g",HMAX);
            SetDlgItemText(hdwnd,IDNUM_METHMAX,bob);
             sprintf(bob,"%g",HMIN);
            SetDlgItemText(hdwnd,IDNUM_METHMIN,bob);
            sprintf(bob,"%g",BOUND);
            SetDlgItemText(hdwnd,IDNUM_BOUNDS,bob);
            return 1;
      
         case WM_COMMAND:
            switch(LOWORD(wparam)){
                   case IDNUM_METHCAN:
                   EndDialog(hdwnd,0);
                   return 1; /* do nothing */
                   case IDNUM_METHOK:
                   /*  check button status  */
                   for(i=0;i<=10;i++){
                       if(SendDlgItemMessage(hdwnd,IDNUM_DISCRETE+i,BM_GETCHECK,0,0))
                       ick=i;
                   }

                   GetDlgItemText(hdwnd,IDNUM_METHTOL,bob,250);
                   TOLER=atof(bob);
                   GetDlgItemText(hdwnd,IDNUM_METHATOL,bob,250);
                   ATOLER=atof(bob);
                    GetDlgItemText(hdwnd,IDNUM_METHMIN,bob,250);
                   HMIN=atof(bob);
                    GetDlgItemText(hdwnd,IDNUM_METHMAX,bob,250);
                   HMAX=atof(bob);
                   GetDlgItemText(hdwnd,IDNUM_TIMTEND,bob,250);
                   TEND=atof(bob);
                   GetDlgItemText(hdwnd,IDNUM_BOUNDS,bob,250);
                   BOUND=atof(bob);
                   GetDlgItemText(hdwnd,IDNUM_TIMTRANS,bob,250);
                   TRANS=atof(bob);
                   GetDlgItemText(hdwnd,IDNUM_TIMT0,bob,250);
                   T0=atof(bob);
                   GetDlgItemText(hdwnd,IDNUM_TIMDT,bob,250);
                   DELTA_T=atof(bob);
                   GetDlgItemText(hdwnd,IDNUM_TIMDEL,bob,250);
                   DELAY=atof(bob);
                   GetDlgItemText(hdwnd,IDNUM_TIMNOUT,bob,250);
                   NJMP=atoi(bob);
                   EndDialog(hdwnd,0);
                   if(ick>=0&&ick<11)METHOD=ick;
                   if(DELTA_T==0)DELTA_T=olddt;
                   free_delay();
                   if(DELAY>0.0){
                   if(alloc_delay(DELAY)){
                    INFLAG=0;
                    }
                    }
                  if(NKernel>0){
                         INFLAG=0;
                         MyStart=1;
                         alloc_kernels(1);
                       }
                   if(NJMP<=0)NJMP=1;
                    if(METHOD==VOLTERRA&&NKernel==0)METHOD=3;
                       if(NKernel>0)METHOD=VOLTERRA;
                   FOREVER=0;
                          if(TEND<0)
                          {
                            FOREVER=1;
                            TEND=-TEND;
                          }
                   if(METHOD==VOLTERRA){
                         tmp=MaxPoints;
                        /* new_int("MaxPoints:",&tmp);
                         new_int("AutoEval(1=yes) :",&AutoEvaluate); */
                         allocate_volterra(tmp,1);
                       }
                      do_meth(); 
                   return 1;
                   }
     }
     return 0;
 }        

do_meth()
{
 if(NKernel>0)METHOD=VOLTERRA;
 switch(METHOD)
 {
  case 0: solver=discrete; POIMAP=0;break;
  case 1: solver=euler;break;
  case 2: solver=mod_euler;break;
  case 3: solver=rung_kut;break;
  case 4: solver=adams;break;
  case VOLTERRA: solver=volterra;break;
  case BACKEUL: solver=bak_euler;break;
  case GEAR:
  case RKQS:
  case STIFF:
  case CVODE:
    NJMP=1; break;
  default: solver=rung_kut;
 }
}


chk_delay()
{
  if(DELAY>0.0) {
                          free_delay();
                          if(alloc_delay(DELAY)){
                            INFLAG=0; /*  Make sure no last ics allowed */
                          }
                        }
                          else 
                            free_delay();
}

set_delay()
{
 if(NDELAYS==0)return;
 if(DELAY>0.0){
   free_delay();
   if(alloc_delay(DELAY)){
     INFLAG=0;
   }
 }
} 
