#include <windows.h>
#include <windowsx.h>
#include <string.h>
#include <stdio.h>
#include <commctrl.h>
#include "menu.h"
#include "globals.h"
#include "main.h"
#include "structs.h"
#include "wppfuns.h"
#include "mousey.h"
#include "animate.h"

#include "lbf_pp.h"
#define A_ABORT_ID 15007
#define MB(a) MessageBox(NULL,a,"",MB_OK)
int calcflag=0,stoprangeflag=0;

int BCSize=8;

#define Window HWND

#define STOP_ID 502
#define STOPRANGE_ID 505

#define ID_P1 503
HDC gc_graph;
BOOL CALLBACK LBFEQDialogFunc(HWND ,UINT ,WPARAM ,LPARAM );
BOOL CALLBACK LBFFPDialogFunc(HWND ,UINT ,WPARAM ,LPARAM );
BOOL CALLBACK LBFPSDialogFunc(HWND ,UINT ,WPARAM ,LPARAM );
BOOL CALLBACK LBFLCDialogFunc(HWND ,UINT ,WPARAM ,LPARAM );
BOOL CALLBACK LBFNumDialogFunc(HWND ,UINT ,WPARAM ,LPARAM );
BOOL CALLBACK LBFDelDialogFunc(HWND ,UINT ,WPARAM ,LPARAM );
BOOL CALLBACK LBFPlotDialogFunc(HWND ,UINT ,WPARAM ,LPARAM );
BOOL CALLBACK LBFAddDialogFunc(HWND ,UINT ,WPARAM ,LPARAM );

BOOL CALLBACK HistDialogFunc(HWND ,UINT ,WPARAM ,LPARAM );
BOOL CALLBACK FourierDialogFunc(HWND ,UINT ,WPARAM ,LPARAM );
BOOL CALLBACK FreezeDialogFunc(HWND ,UINT ,WPARAM ,LPARAM );
BOOL CALLBACK EqRangeDialogFunc(HWND ,UINT ,WPARAM ,LPARAM );
BOOL CALLBACK Range2DialogFunc(HWND ,UINT ,WPARAM ,LPARAM );
BOOL CALLBACK BvpRangeDialogFunc(HWND ,UINT ,WPARAM ,LPARAM );
BOOL CALLBACK IntRangeDialogFunc(HWND ,UINT ,WPARAM ,LPARAM );
BOOL CALLBACK PoincareDialogFunc(HWND ,UINT ,WPARAM ,LPARAM );
BOOL CALLBACK ColorDialogFunc(HWND ,UINT ,WPARAM ,LPARAM);
BOOL CALLBACK PhaseDialogFunc(HWND,UINT,WPARAM,LPARAM);
BOOL CALLBACK XvstDialogFunc(HWND,UINT,WPARAM,LPARAM);
BOOL CALLBACK RuelleDialogFunc(HWND,UINT,WPARAM,LPARAM);
BOOL CALLBACK NumCtlDialogFunc(HWND,UINT,WPARAM,LPARAM );
extern struct {
         int x0,y0;
         int x1,y1;
         int flag;
}  rubber_info;
int palflag=0;
extern int DF_FLAG;
char this_file[256];
HWND mainwnd,browsewnd,draw_win;
int Xup;
extern int DF_FLAG;
extern int SCALEX,SCALEY;
int tfBell=1;
int XPPBatch=0,batch_range=0;
char batchout[256];
int LookingForMouse=0; 
extern int storind;
char *get_first();
char *get_next();
HCURSOR ArrowCursor,WaitCursor;
WNDCLASS wclauto;
HWND stop,spar1,stop_range;
HWND cposit;
char szWinName[] = "WPP";
char popWinName[]="POP";
char browseWinName[]="BROWSE";
char autowinname[]="AUTO";
char addWinName[]="GRAPH";
HINSTANCE hInst;
/* WinMainCRTStartup()
{
} */
int WINAPI WinMain(HINSTANCE hThisInst,HINSTANCE hPrevInst,
                    LPSTR lpszArgs, int nWinMode)
{
    
   
    HWND child,junk;
  int count,argc;
  char **argv;
  char *ptr,*ptr2,*ms;
  int i;
  char bob[256];
  HACCEL hAccel;
  MSG msg;
 
 WNDCLASS wcl,wclpop,wclbrowse,wclgraph;
    OpenLogFile();
    sprintf(batchout,"output.dat");
    argc=1;   
    argv=(char **)malloc(8*sizeof(char *));
    argv[0]=(char *)malloc(7);
    strcpy(argv[0],"wppint");
    i=1;
    if(strlen(lpszArgs)>0){
    ptr=lpszArgs;
    ptr2=get_first(ptr," ");
    if(strlen(ptr2)!=0){
         argv[1]=(char *)malloc(strlen(ptr2)+1);
         strcpy(argv[1],ptr2);
         i=2;
        while((ms=get_next(" \n"))!=NULL)
        {
           argv[i]=(char *)malloc(strlen(ms)+1);
           strcpy(argv[i],ms);
           i++;
           if(i>=8)break;
        }
    }
 argc=i;
    }
 if(argc==1)    
    opensave(0,hThisInst,this_file,"Load ODE File");
 else
    strcpy(this_file,argv[1]);

   if(strlen(this_file)==0){
   MessageBox(NULL,"No Filename Selected","Bye Bye",MB_OK);
   return 0;
   }
  
 /* now we have a file name */
    /* test_the_file(this_file); */
    if(load_eqn(this_file)==0)
    Err_Exit("Failed to load the file! \n");
    
    set_all_vals();

   

    set_init_guess();
    do_meth();
    set_delay();
   /*    all the initial data stufff  */
/****************************************************/

   /* InitFalseWPP(); */
 /****************************************************/
 

 wclauto.hInstance=hThisInst;
    wclauto.lpszClassName=autowinname;
    wclauto.lpfnWndProc=WindowFunc;
    wclauto.style=CS_NOCLOSE|CS_HREDRAW|CS_VREDRAW;
    
    wclauto.hCursor=LoadCursor(NULL,IDC_ARROW);
    wclauto.lpszMenuName="LBFMENU";
    wclauto.cbClsExtra=0;
    wclauto.cbWndExtra=0;

    wclauto.hbrBackground = (HBRUSH) GetStockObject(WHITE_BRUSH);

    if(!RegisterClass(&wclauto)) {
       MB("Couldnt register lbfwin");
        return 0;
    }

 wclbrowse.hInstance=hThisInst;
    wclbrowse.lpszClassName=browseWinName;
    wclbrowse.lpfnWndProc=WindowFunc;
    wclbrowse.style=CS_NOCLOSE|CS_HREDRAW|CS_VREDRAW;
    wclbrowse.hIcon=LoadIcon(hThisInst,"BROWICON");
    wclbrowse.hCursor=LoadCursor(NULL,IDC_CROSS);
    wclbrowse.lpszMenuName="BROWSMENU";
    wclbrowse.cbClsExtra=0;
    wclbrowse.cbWndExtra=0;

    wclbrowse.hbrBackground = (HBRUSH) GetStockObject(WHITE_BRUSH);

    
    if(!RegisterClass(&wclbrowse)) return 0;
    
    ArrowCursor=LoadCursor(NULL,IDC_ARROW);
    WaitCursor=LoadCursor(NULL,IDC_WAIT);

    
    wcl.hInstance=hThisInst;
    wcl.lpszClassName=szWinName;
    wcl.lpfnWndProc=WindowFunc;
    wcl.style=CS_NOCLOSE|CS_HREDRAW|CS_VREDRAW;
    wcl.hIcon=LoadIcon(hThisInst,"WPPICON");
    wcl.hCursor=NULL;
    wcl.lpszMenuName="WPPMENU";
    wcl.cbClsExtra=0;
    wcl.cbWndExtra=0;

    wcl.hbrBackground = (HBRUSH) GetStockObject(WHITE_BRUSH);


   /* PlaySound("wav/hello.wav",NULL,SND_ASYNC); */

    if(!RegisterClass(&wcl)) return 0;

     SetCursor(ArrowCursor);
 wclpop.hInstance=hThisInst;
    wclpop.lpszClassName=popWinName;
    wclpop.lpfnWndProc=WindowFunc;
    wclpop.style=CS_NOCLOSE|CS_HREDRAW|CS_VREDRAW;
    wclpop.hIcon=LoadIcon(hThisInst,"POPICON");
    wclpop.hCursor=LoadCursor(NULL,IDC_CROSS);
    wclpop.lpszMenuName=NULL;
    wclpop.cbClsExtra=0;
    wclpop.cbWndExtra=0;

    wclpop.hbrBackground = (HBRUSH) GetStockObject(WHITE_BRUSH);

   
    
  

  
    if(!RegisterClass(&wclpop)) return 0;
    
    
      wclgraph.hInstance=hThisInst;
    wclgraph.lpszClassName=addWinName;
    wclgraph.lpfnWndProc=WindowFunc;
    wclgraph.style=CS_HREDRAW|CS_VREDRAW;
    wclgraph.hIcon=LoadIcon(hThisInst,"POPICON");
    wclgraph.hCursor=LoadCursor(NULL,IDC_CROSS);
    wclgraph.lpszMenuName="GRAPHMENU";
    wclgraph.cbClsExtra=0;
    wclgraph.cbWndExtra=0;

    wclgraph.hbrBackground = (HBRUSH) GetStockObject(WHITE_BRUSH);

   
    
  

  
    if(!RegisterClass(&wclgraph)) return 0;
   /*  make_std_colors(); */
    make_palette(100);
    mainwnd= CreateWindow(
          szWinName, "WINPP The Dynamical Systems Tool",
          WS_OVERLAPPEDWINDOW,
          CW_USEDEFAULT,
          CW_USEDEFAULT,
          640,
          500,
          HWND_DESKTOP,
          NULL,hThisInst,NULL);


          hInst=hThisInst;
          
     ShowWindow(mainwnd,nWinMode);
     UpdateWindow(mainwnd);
     create_std_fonts(mainwnd,BCSize);
/* Load accelerator keys   */
hAccel=LoadAccelerators(hThisInst,"WPPMENU");

 
 stop=CreateWindow("button","STOP",WS_CHILD,5,5,60,20,mainwnd,STOP_ID,hThisInst,NULL);
 stop_range=CreateWindow("button","Abort all",WS_CHILD,5,26,80,18,mainwnd,STOPRANGE_ID,hThisInst,NULL);
 ShowWindow(stop,nWinMode);
 ShowWindow(stop_range,nWinMode);

 UpdateWindow(stop);
 
 

 CreateProgressBar(mainwnd,0,100,1,70,5,500,20);

 init_grafs(100,100,100,100); 
 /* create_a_pop();
 create_a_pop(); */
 
 
/*  TestSlider(mainwnd,20,300); */
 browsewnd= CreateWindow(
          "BROWSE", "Browser",
               WS_OVERLAPPEDWINDOW|WS_HSCROLL|WS_VSCROLL,
          CW_USEDEFAULT,
          CW_USEDEFAULT,
          400,
          200,
          HWND_DESKTOP,
          NULL,hThisInst,NULL);
  
    
   
 
 init_browser(browsewnd);
  SetStopBtn(0);
    InitCommonControls();  
     ShowWindow(browsewnd,nWinMode);
     UpdateWindow(browsewnd);
      ArrangeMainWnd();
     refresh_browser(0);      
  initialize_box();
 
 /*  MB(this_file); */




     while(GetMessage(&msg,NULL,0,0))
     {
        if(!TranslateAccelerator(mainwnd,hAccel,&msg)){
            /* if(!TranslateAccelerator(hwnd,hAccel,&msg)){ */
         if(!HandleSelfKill(&msg)&&!HandleBoxListTab(&msg)
         &&!HandleSingMsg(&msg)&&!HandleToonMsg(&msg)&&!HandleAplotMsg(&msg)){    
         TranslateMessage(&msg);
         DispatchMessage(&msg);
         }
         }
   }
   /* } */
    
      return msg.wParam;
}

 
  RepaintStuff( w)
  Window w;
  {
      HDC dc;

      PAINTSTRUCT ps;  
      /*dc=BeginPaint(w,&ps); */
      dc=gc_graph;
      gc_graph=GetDC(w);
      if(gc_graph==NULL)lprintf("Cant get a DC!! \n");
      set_palette(gc_graph);      
      if(w==browsewnd){
           paintbrowser(w,gc_graph); 
            } 
      else {
       PaintWindow(w); 
      }
      ReleaseDC(w,gc_graph);
      gc_graph=dc;
      set_palette(gc_graph);
        
  }

  
  PaintWindow(w)
  Window w;
  /* HDC dc; */
  
  {
    /* gc_graph=dc; */
    expose_pop(w);
    expose_lbf(w);
  
  
  }
                     
                  
                   
                    
                     
  LRESULT CALLBACK WindowFunc(HWND hwndz,UINT message,
                     WPARAM wparam,LPARAM lparam)
   {
      
      int response;
      char bob[256];
      int cx,cy,i;
      SIZE sz;
      PAINTSTRUCT ps;  
   
     
      
      if(calcflag==0){
    
      if(HandleBrowser(hwndz,message,wparam,lparam)==1)return 0;
      if(HandleParamSlider(hwndz,message,wparam,lparam)==1)return 0;
    
      
      switch(message) {
       case WM_CREATE:
                      LookingForMouse=0;
                      break;
       case WM_SIZE:
                  cx=LOWORD(lparam);
                  cy=HIWORD(lparam);
                  ResizeWindow(hwndz,cx,cy);
                  break;
        case WM_LBUTTONUP:
        case WM_RBUTTONUP:
               if(LookingForMouse==RUBBER_LINE
               ||LookingForMouse==RUBBER_BOX){
                  RubberStuff(hwndz,LOWORD(lparam),HIWORD(lparam),
                  LookingForMouse,RUBBER_UP);
                  LookingForMouse=0;
                /*  lprintf("up here\n"); */
                  DeleteSelfKill();
               }
               else  ButtonDownStuff(hwndz,LOWORD(lparam),HIWORD(lparam),2);
                  break;       
        case WM_LBUTTONDOWN:
        case WM_RBUTTONDOWN:
              if(LookingForMouse>0)
              CheckMouseDown(hwndz,LOWORD(lparam),HIWORD(lparam),
              &LookingForMouse);
              else  ButtonDownStuff(hwndz,LOWORD(lparam),HIWORD(lparam),0);
              break;               
        case WM_MOUSEMOVE:
               if(wparam==MK_LBUTTON&&LookingForMouse==0)   
               ButtonDownStuff(hwndz,LOWORD(lparam),HIWORD(lparam),1);
               if(wparam==MK_LBUTTON&&LookingForMouse>0)
                RubberStuff(hwndz,LOWORD(lparam),HIWORD(lparam),
                  LookingForMouse,RUBBER_MOVE);
               break;
                         
        case WM_PAINT:
                 BeginPaint(hwndz,&ps);
                 EndPaint(hwndz,&ps);
                 RepaintStuff(hwndz);    
                   
                     break; 
          case WM_COMMAND:
                if(toggle_pop(lparam))break;
                if(box_buttons(wparam))break;
                switch(LOWORD(wparam)){
                    case IDM_REDRAW:
                    redraw_the_graph();
                    break;
                    case IDM_COLOR:
                     DialogBox(hInst,"COLORDIALOG",hwndz,ColorDialogFunc);
                       break;
                    case IDM_LBF:
                          init_lbfctl();
                          break;   
                    case IDM_ADD:
                       DialogBox(hInst,"NGDIALOG",hwndz,NewGraphDialogFunc);
                       break;
                    case IDM_FRZCRV:
                       DialogBox(hInst,"FREEZEDIALOG",hwndz,FreezeDialogFunc);
                       break;   
                    case IDM_ERASE:
                        clear_window();
                        DF_FLAG=0;
                        break;
                    case IDM_ARRAY:
                           new_array();
                           break;   
                    case IDM_PSCOL:
                           create_ps(1);
                           break;
                    case IDM_PSBW:
                           create_ps(0);
                           break;           
                    case IDM_ADDWIN:
                           create_a_pop();
                           break;    
                    case IDM_DIRFLD:
                          phaseplane(0);
                          break;
                    case IDM_COLPP:
                          phaseplane(3);
                          break;      
                    case IDM_FLOW:
                          phaseplane(1);
                          break;
                    case IDM_CONT:
                        get_more_time();
                        break;      
                    case IDM_SHOOT1:
                          shoot_ics(1);
                          break;
                      case IDM_SHOOT2:
                          shoot_ics(2);
                          break;
                     case IDM_SHOOT3:
                          shoot_ics(3);
                          break;
                       case IDM_SHOOT4:
                          shoot_ics(4);
                          break;                     
                    case IDM_NCLINES:
                          phaseplane(4);
                          break;
                    case IDM_REDRAWN:
                          phaseplane(5);
                          break;
                    case IDM_ZOOM:
                        InitRubber(ZOOM_IN,&LookingForMouse);
                        break;
                    case IDM_ZOOMOUT:
                        InitRubber(ZOOM_OUT,&LookingForMouse);
                        break;                              
                    case IDM_FIT:
                        fit_window();
                        redraw_the_graph();
                        break;
                    case IDM_POINCARE:
                            DialogBox(hInst,"PMAPDIALOG",hwndz,PoincareDialogFunc);
                            break;
                    case IDM_SEED:
                           new_seed();
                            break;
                    case IDM_FOURIER:
                             DialogBox(hInst,"FOURDLG",hwndz,FourierDialogFunc);
                             break;
                    case IDM_HIST:
                             DialogBox(hInst,"HISTDLG",hwndz,HistDialogFunc);
                             break;          
                    case IDM_MEAN:
                     mean_back();
                        break;
                    case IDM_VARI:
                    variance_back();
                           break;
                    case IDM_COMPUTE:
                    compute_em();
                      break;
                    case IDM_DATA:
                    data_back();
                       break;                
                    case IDM_GRIDPP:
                            DialogBox(hInst,"PHASEDIALOG",hwndz,PhaseDialogFunc);
                            break;    
                    case IDM_LAST:
                          integr_last(0);
                          break;
                    case IDM_BWRITE:
                          save_br_data();
                          break;
                    case IDM_BLOAD:
                          load_br_data();
                          break;
                    case IDM_BGET:
                          get_br_row();
                          break;
                    case IDM_BFIND:
                          browser_find();
                          break;
                    case IDM_BREPLACE:
                          browser_replace();
                          break;
                    case IDM_BADDCOL:
                          browser_addcol();
                          break;
                    case IDM_BDELCOL:
                          browser_delcol();
                          break;
                    case IDM_BUNREP:
                          browser_unreplace();
                          break;                              
                    case IDM_CLIP:
                          copy_to_clip();
                          break;
                    case IDM_RANGE:
                           DialogBox(hInst,"INTRANGEDIALOG",NULL,IntRangeDialogFunc);
                           do_range();
                           break;
                    case IDM_RANGE2:
                           DialogBox(hInst,"RANGE2DIALOG",NULL,Range2DialogFunc);
                           do_range();
                           break;       
                    case IDM_NEW:
                   
                       /* tst_gr(); */
                       
                      test_manic(); 
                      break;                  
                    case IDM_GO:
                       /* make_my_modal(); */
                       /* lprintf("Calculating \n"); */
                        /* calculate();  */
                        test_run();
                        break;
                    case IDM_SMOUSE:
                    LookingForMouse=MOUSE_FP;
                    SelfKill("Click on Guess");
                    break;  
                    case IDM_MOUSE:
                   
                    LookingForMouse=MOUSE_GO;
                    SelfKill("Click on IC");
                  
                    break;
                    case IDM_MICE:
                    
                     LookingForMouse=MOUSE_MANY;
                     SelfKill("Click Stop to finish");
                     
                     break;
                    
                    case IDM_SRANGE:
                        DialogBox(hInst,"FPRANGEDIALOG",NULL,EqRangeDialogFunc);
                           do_eq_range();
                           break;
                    case IDM_SGO:
                         find_equilibrium(0);
                         break;    
                    case IDM_BVPSHOW:
                        solve_bvp(0);
                        break;
                    case IDM_BVPNOSHOW:
                        solve_bvp(1);
                        break;
                    case IDM_BVPRANGE:
                            DialogBox(hInst,"BVPRANGEDIALOG",NULL,BvpRangeDialogFunc);
                            do_bvp_range();
                            break;       
                             
                    case STOP_ID:
                         if(calcflag==0){
                          RubberStuff(hwndz,0,0,LookingForMouse,RUBBER_ABORT);    
                         LookingForMouse=0;
                         DeleteSelfKill();
                         }
                        
                         calcflag=0;
                         SetCursor(ArrowCursor);
                         break;
                    case IDM_CONTROL:
                          DialogBox(hInst,"NUM_CTL",hwndz,NumCtlDialogFunc);
                          break;     
                    case IDM_METHOD:
                          DialogBox(hInst,"METHDIALOG",hwndz,MethDialogFunc);
                          
                          break;
                    case IDM_RUELLE:
                          DialogBox(hInst,"RUELLEDIALOG",hwndz,RuelleDialogFunc);
                          break;
                    case IDM_PHASE:
                         
                           do_torus(); 
                          break;
                    case IDM_TRANSPOSE:
                        do_transpose();
                         break;
                    case IDM_NADJ:
                        new_adjoint();
                        break;
                    case IDM_NH:
                        new_h_fun();
                        break;
                    case IDM_H:
                          h_back();
                          break;
                    case IDM_ADJ:
                          adj_back();
                          break;
                    case IDM_ORBIT:
                          data_back();
                          break;                                     

                   case IDM_WINDOW:
                          DialogBox(hInst,"VIEWDIALOG",hwndz,ViewDialogFunc);
                          
                          break;
                    case IDM_XVST:
                          DialogBox(hInst,"XVSTDIALOG",hwndz,XvstDialogFunc);
                          break;
                    case IDM_TOON:
                            new_vcr();
                            break;   
                    case IDM_EDRHS:
                        edit_rhs(hwndz);
                        break;            
                    case IDM_READSET:
                       do_lunch(1);
                       break;
                    case IDM_WRITESET:
                       do_lunch(0);
                       break;
                    case IDM_QUIT:
                   /*  PlaySound("wav/thallf.wav",NULL,SND_ASYNC); */
                        if(MessageBox(hwndz,"Really quit?","ByeBye", MB_YESNO)==IDYES){
                            
                            CloseLogFile();
                        PostQuitMessage(0);
                        }
                        break;
                     case LBF_SAVE:
                     case LBF_LOAD:
                     break;
                     case LBF_COPY:
                     lbf_copy_to_clip();
                     break;
                     case LBF_NEWCRV:
                     DialogBox(hInst,"LBFADD",hwndz,LBFAddDialogFunc);
                     break;  
                 case LBF_DELCRV:
                     DialogBox(hInst,"LBFCRVDEL",hwndz,LBFDelDialogFunc);
                      break;    
                   case LBF_NUM:
                     DialogBox(hInst,"LBFNUM",hwndz,LBFNumDialogFunc);
                      break; 
                     case LBF_PLOT:
                     DialogBox(hInst,"LBFPLOT",hwndz,LBFPlotDialogFunc);
                       break;
                     case LBF_REDRAW:
                     redraw_diagram();
                      break;
                     case LBF_CTLEQ:
                     DialogBox(hInst,"LBFEQCRV",hwndz,LBFEQDialogFunc);
                     break;  
                     case LBF_CTLFP:
                      DialogBox(hInst,"LBFFPCRV",hwndz,LBFFPDialogFunc);
                     break;  
                     case LBF_CTLPS:
                      DialogBox(hInst,"LBFPSCRV",hwndz,LBFPSDialogFunc);
                     break;  
                     case LBF_CTLLC:
                      DialogBox(hInst,"LBFLCCRV",hwndz,LBFLCDialogFunc);
                     break;  
                     
                      case A_TRAV_ID:
                     case A_LEFT_ID:
                     case A_RIGHT_ID:
                     case A_JUMP_ID:
                     case A_HOME_ID:
                     case A_GRAB_ID:
                     case A_ESC_ID:
                    
                      auto_button_stuff(LOWORD(wparam)-A_TRAV_ID);
                      break;

                }
                break;
        case WM_KEYDOWN:
                   
                   if(auto_key_stuff(hwndz,wparam)) break;

            
                   switch(wparam){
                       case VK_ESCAPE:
                           
                           RubberStuff(hwndz,0,0,LookingForMouse,RUBBER_ABORT);    
                         LookingForMouse=0;
                         DeleteSelfKill();
                          break;
                       
                   }
                   break;  
          case WM_CLOSE:
               destroy_a_pop(hwndz);
               break;
                  
               
           
           
          default:
               return DefWindowProc(hwndz,message,wparam,lparam);
      }
      }
      else {
             switch(message){
                 case WM_COMMAND:
                        switch(GET_WM_COMMAND_ID(wparam,lparam)){
                          case STOP_ID:
                                calcflag=0;
                                break;
                          case STOPRANGE_ID:
                                stoprangeflag=0;
                                break; 
                          case A_ABORT_ID:
                               calcflag=0;
                               break;                           
                                       
                        }
                break;
                case WM_KEYDOWN:
                   switch(wparam){
                       case VK_ESCAPE:
                          calcflag=0;
                          break;
                       case VK_BACK:
                        stoprangeflag=0;
                        break;
                   }
                   break;   
                case WM_PAINT:
                  BeginPaint(hwndz,&ps);
                 EndPaint(hwndz,&ps);
                   RepaintStuff(hwndz);
                   break;
           default:
               return DefWindowProc(hwndz,message,wparam,lparam);
             }   
     
      }
      return 0;
  }

 LRESULT CALLBACK popWindowFunc(HWND hwnd,UINT message,
                     WPARAM wparam,LPARAM lparam)
   {
      HDC hdc;
      int response;
      PAINTSTRUCT paintstruct;             
      switch(message) {
       
          case WM_DESTROY:
             
                    MB("Not here buddy!");
               
           
               break;
          default:
               return DefWindowProc(hwnd,message,wparam,lparam);
      }
      return 0;
  }

winpp_range()
{
       DialogBox(hInst,"INTRANGEDIALOG",NULL,IntRangeDialogFunc);
                           do_range();
}                    

SetStopBtn(BOOL f)
{
   /* EnableWindow(stop,f);
    EnableWindow(stop_range,f); */
}



