#include <windows.h>
#include <windowsx.h>

#include <stdio.h>
#include <math.h>
#include <ctype.h>
#include "structs.h"
double atof();
#include "aplot.h"
#define FIRSTCOLOR 12

#define FIX_MIN_SIZE 2

#define GREYSCALE -1
#define REDBLUE  0
#define ROYGBIV  1
#define PERIODIC 2

extern char uvar_names[MAXODE][12];

extern int color_total,NEQ;
extern BROWSER my_browser;

typedef struct {
   HWND pix,scale,w; 
  int index0,alive,nacross,ndown;
  int ploth,plotw;
  int nstart,nskip;
  double zmin,zmax;
  char xtitle[256],ytitle[256],filename[256],bottom[256];
  int type;
} APLOT;

APLOT aplot;

HDC aplot_gc;
HBITMAP aplotbitmap;

extern HINSTANCE hInst;



BOOL CALLBACK APEditDialogFunc(HWND hwnd,UINT message,
                     WPARAM wparam,LPARAM lparam)
{
    int i,indexn;
    char temp[256];
    switch(message){
                case WM_INITDIALOG:
                sprintf(temp,"t");
                 SendDlgItemMessage(hwnd,APED_COL1,LB_ADDSTRING,0,
                   (LPARAM)temp);
                SendDlgItemMessage(hwnd,APED_COLN,LB_ADDSTRING,0,
                   (LPARAM)temp);
                for(i=0;i<NEQ;i++){
                sprintf(temp,"%s",uvar_names[i]);
                strlwr(temp); 
                SendDlgItemMessage(hwnd,APED_COL1,LB_ADDSTRING,0,
                   (LPARAM)temp);
                SendDlgItemMessage(hwnd,APED_COLN,LB_ADDSTRING,0,
                   (LPARAM)temp);
                }
                indexn=aplot.index0+aplot.nacross-1;
                SendDlgItemMessage(hwnd,APED_COL1,LB_SETCURSEL,aplot.index0,0L);     
                 SendDlgItemMessage(hwnd,APED_COLN,LB_SETCURSEL,indexn,0L);
                 sprintf(temp,"%g",aplot.zmin);
                 SetDlgItemText(hwnd,APED_ZMIN,temp);
                 sprintf(temp,"%g",aplot.zmax);
                 SetDlgItemText(hwnd,APED_ZMAX,temp);
                 sprintf(temp,"%d",aplot.nstart);
                 SetDlgItemText(hwnd,APED_ROW1,temp);                           
                  sprintf(temp,"%d",aplot.ndown);
                 SetDlgItemText(hwnd,APED_NROW,temp);
                 sprintf(temp,"%d",aplot.nskip);
                 SetDlgItemText(hwnd,APED_ROWSKIP,temp);
                 return 1;

            case WM_COMMAND:
                switch(LOWORD(wparam)){
                        case IDCANCEL:
                                  EndDialog(hwnd,0);
                                  return 1;
                        case IDOK:
                                i=SendDlgItemMessage(hwnd,APED_COL1,LB_GETCURSEL,
                                 0,0L);
                                indexn=SendDlgItemMessage(hwnd,APED_COLN,LB_GETCURSEL,
                                 0,0L);
                                if(i>=0&&i<=indexn&&indexn<=NEQ){
                                        aplot.index0=i;
                                        aplot.nacross=indexn-i+1;
                                        }
                                GetDlgItemText(hwnd,APED_ZMIN,temp,255);
                                aplot.zmin=atof(temp);        
                                GetDlgItemText(hwnd,APED_ZMAX,temp,255);
                                aplot.zmax=atof(temp);
                                GetDlgItemText(hwnd,APED_ROW1,temp,255);
                                aplot.nstart=atoi(temp);         
                                GetDlgItemText(hwnd,APED_NROW,temp,255);
                                aplot.ndown=atoi(temp);
                                GetDlgItemText(hwnd,APED_ROWSKIP,temp,255);
                                aplot.nskip=atoi(temp);
                                EndDialog(hwnd,0);
                                DrawNewAplot();
                                RedrawAplot(aplot.scale,aplot.pix);
                                return 1;
                }
                return 0;
    }
    return 0;
} 
                                
                                              
SetAplotTextStuff()
{
    int nrows=my_browser.maxrow;
  int row0=aplot.nstart;
  int i0=aplot.index0-1,i1=aplot.index0+aplot.nacross-2;
  int ib,jb,ix,iy;
  float tlo,thi;
  char bob[256],s0[100];
  HWND w=aplot.w;
  if(nrows<=2)return;
  jb=row0;
  tlo=0.0;
  thi=20.0;
  if(jb>0&&jb<nrows)tlo=my_browser.data[0][jb];
  jb=row0+aplot.nskip*(aplot.ndown-1);
  if(jb>=nrows)jb=nrows-1;
  if(jb>=0)thi=my_browser.data[0][jb];
  sprintf(bob,"t=%g",tlo);
  SetDlgItemText(w,AP_T0,bob);
  sprintf(bob,"t=%g",thi);
  SetDlgItemText(w,AP_T1,bob);
  sprintf(bob,"%g",aplot.zmin);
  SetDlgItemText(w,AP_ZLO,bob);
    sprintf(bob,"%g",aplot.zmax);
  SetDlgItemText(w,AP_ZHI,bob);
  if(i0<0)strcpy(s0,"t");
  else strcpy(s0,uvar_names[i0]);
  sprintf(bob,"%s...%s",s0,uvar_names[i1]);
  SetDlgItemText(w,AP_TOPCAP,bob);  

}

BOOL CALLBACK APPrtDialogFunc(HWND hwnd,UINT message,
                     WPARAM wparam,LPARAM lparam)
{
        int i;
        char temp[256];
        switch(message){
            case WM_INITDIALOG:
            
            SetDlgItemText(hwnd,APR_BOTTOM,aplot.bottom);
            SetDlgItemText(hwnd,APR_SIDE,aplot.ytitle);
            SetDlgItemText(hwnd,APR_TOP,aplot.xtitle);
            sprintf(temp,"Grey");
            SendDlgItemMessage(hwnd,APR_RENDER,LB_ADDSTRING,0,(LPARAM)temp);
             sprintf(temp,"RedBlue");
            SendDlgItemMessage(hwnd,APR_RENDER,LB_ADDSTRING,0,(LPARAM)temp);
             sprintf(temp,"ROYGBIV");
            SendDlgItemMessage(hwnd,APR_RENDER,LB_ADDSTRING,0,(LPARAM)temp);
             sprintf(temp,"Periodic");
            SendDlgItemMessage(hwnd,APR_RENDER,LB_ADDSTRING,0,(LPARAM)temp);
            SendDlgItemMessage(hwnd,APR_RENDER,LB_SETCURSEL,aplot.type+1,0L);
            return 1;
            case WM_COMMAND:
                switch(LOWORD(wparam)){
                    case IDCANCEL:
                        EndDialog(hwnd,0);
                        return 1;
                    case IDOK:
                        GetDlgItemText(hwnd,APR_BOTTOM,aplot.bottom,255);    
                        GetDlgItemText(hwnd,APR_TOP,aplot.xtitle,255);
                        GetDlgItemText(hwnd,APR_SIDE,aplot.ytitle,255);
                        i=SendDlgItemMessage(hwnd,APR_RENDER,LB_GETCURSEL,0,0L);
                        if(i>=0)aplot.type=i-1;
                        aplot.filename[0]=0;
                        EndDialog(hwnd,0);
                         opensave(1,hInst,aplot.filename,"Print to file");
                        print_aplot();
                        return 1;
                }
                return 0;
        }
      return 0;  
                        
}
                         

BOOL CALLBACK APlotDialogFunc(HWND hwnd,UINT message,
                     WPARAM wparam,LPARAM lparam)
 {
     static HWND pix,scale,wthi;
     static int scx=100,scy=10;
     static int p_left,p_top;
     int cx,cy,cbot;
     char bob[256];
     RECT r;
     HDC hdc;
     switch(message){
         case WM_INITDIALOG:
          aplot.w=hwnd;
          p_left=55;
          p_top=75;
          pix=GetDlgItem(hwnd,AP_PIX);
          aplot.pix=pix;
          scale=GetDlgItem(hwnd,AP_SCALE);
          aplot.scale=scale;
          wthi=GetDlgItem(hwnd,AP_T1);      

          GetWindowDimensions(pix,&cx,&cy);
          hdc=GetDC(pix);
          aplot_gc=CreateCompatibleDC(hdc);
          set_palette(aplot_gc);
          aplotbitmap=CreateCompatibleBitmap(hdc,cx,cy);
          ReleaseDC(pix,hdc);
          SelectObject(aplot_gc,aplotbitmap);
          ClearAPlotBits(cx,cy);
          aplot.alive=1;
        
          return 1;
        case WM_SIZE:
            GetWindowDimensions(hwnd,&cx,&cy);
          if(aplotbitmap)DeleteObject(aplotbitmap);
          cbot=cy;
           MoveWindow(pix,p_left,p_top,cx-p_left-5,cy-p_top-5,TRUE);
          
           GetWindowDimensions(pix,&cx,&cy);
           MoveWindow(wthi,2,p_top+cy-35,25,12,TRUE);
           hdc=GetDC(pix);
           aplotbitmap=CreateCompatibleBitmap(hdc,cx,cy);
          ReleaseDC(pix,hdc);
          SelectObject(aplot_gc,aplotbitmap);
           ClearAPlotBits(cx,cy);
          DrawNewAplot();
           RedrawAplot(scale,pix);
           return 1;
        case WM_PAINT:
         RedrawAplot(scale,pix);
          return 0;

      
        case WM_COMMAND:
           switch(LOWORD(wparam)){
               case AP_REDRAW :
                   DrawNewAplot();
                    RedrawAplot(scale,pix);
                return 1;
                case AP_PRINT:
                         DialogBox(hInst,"APPRINTDIALOG",NULL,APPrtDialogFunc);
                       return 1; 
               case AP_COPY :
                  if(OpenClipboard(NULL)!=0){
                      EmptyClipboard();
                      SetClipboardData(CF_BITMAP,aplotbitmap);
                      CloseClipboard(); }
                  else {
                        err_msg("Couldn't open clipboard!");
                        }
                return 1;
               case AP_DISMISS:
                       aplot.alive=0;
                         DeleteObject(aplotbitmap);
                         DeleteDC(aplot_gc);
                         DestroyWindow(aplot.w);         
                         return 1;
              case AP_EDIT:
                       DialogBox(hInst,"APEDITDIALOG",NULL,APEditDialogFunc);
                       return 1;
           }
            return 0;
     }
        return 0;
 }       

ClearAPlotBits(int w,int h)
   {
        HBRUSH hb;
        hb= SelectObject(aplot_gc,(HBRUSH)GetStockObject(WHITE_BRUSH));
        Rectangle(aplot_gc,-1,-1,w+1,h+1);
        SelectObject(aplot_gc,hb);
   }     

 RedrawAplot(HWND scale,HWND wn)
 {
     int h,w;
        HDC dc;

        if(aplotbitmap){
                InvalidateRect(wn,NULL,TRUE);
                UpdateWindow(wn);
                GetWindowDimensions(wn,&w,&h);
                dc=GetDC(wn);
                BitBlt(dc,0,0,w,h,aplot_gc,0,0,SRCCOPY);
                ReleaseDC(wn,dc);
        }
    

     DrawAplotScale(scale);
 }

 DrawAplotScale(HWND w)
 {
     HDC dc;
     HPEN hp,hpold;
     char bob[256];
     float z;
     int i,k,j,wid,hgt;
     dc=GetDC(w);
     GetWindowDimensions(w,&wid,&hgt);
    
   
     set_palette(dc);
     for(i=0;i<wid;i++){
           z=color_total*i/(float)wid+FIRSTCOLOR;
           j=(int)z;
           hp=CreatePen(0,1,PALETTEINDEX(j));
           hpold=SelectObject(dc,hp);
           MoveToEx(dc,i,0,NULL);
           LineTo(dc,i,hgt);
           SelectObject(dc,hpold);
           DeleteObject(hp);
     }
     ReleaseDC(w,dc);
 }

 HandleAplotMsg(m)
UINT *m;
{
    if(aplot.alive==0)return 0;
    return IsDialogMessage(aplot.w,m);

}    
new_array()
{
    if(aplot.alive)return;
    init_arrayplot();
    aplot.w=CreateDialog(hInst,"APLOTDIALOG",NULL,APlotDialogFunc);
    aplot.alive=1;        
}    
     
 DrawNewAplot()
 {
  RECT r;
  HBRUSH hb,hbold;
  int i,j;
  double z,dx,dy,x,y,tlo,thi;
  int plotw,ploth;
  HWND pix=aplot.pix;
  int nrows=my_browser.maxrow,colr,cmax=FIRSTCOLOR+color_total;
  int row0=aplot.nstart;
  int col0=aplot.index0,delx,dely;
  int ib,jb,ix,iy;
  if(nrows<=2)return;
  if(aplot.nacross<2||aplot.ndown<2)return;
  GetWindowDimensions(pix,&plotw,&ploth);
  dx=(double)plotw/(double)aplot.nacross;
  dy=(double)ploth/(double)aplot.ndown;
  delx=(int)dx+1;
  dely=(int)dy+1;
    for(i=0;i<aplot.nacross;i++){
      ib=col0+i;
      x=dx*i;
      ix=(int)x;
      if(ib>my_browser.maxcol)return ;
      for(j=0;j<aplot.ndown;j++){
        jb=row0+aplot.nskip*j;
        
        if(jb<nrows&&jb>=0){
          y=j*dy;
          iy=(int)y;

          z=(double)color_total*
          (my_browser.data[ib][jb]-aplot.zmin)/(aplot.zmax-aplot.zmin);
          colr=(int)z+FIRSTCOLOR;
          if(colr<FIRSTCOLOR)colr=FIRSTCOLOR;
          if(colr>cmax)colr=cmax;
          hb=CreateSolidBrush(PALETTEINDEX(colr));
          hbold=SelectObject(aplot_gc,hb);
          r.top=y;
          r.bottom=iy+dy+1;
          r.left=ix;
          r.right=ix+dx+1;
          FillRect(aplot_gc,&r,hb);
          SelectObject(aplot_gc,hbold);
          DeleteObject(hb);
        }
      }
    }
    SetAplotTextStuff();
}



init_arrayplot()
{
 
 aplot.zmin=-1.0;
 aplot.zmax=1.0;
 aplot.alive=0;
 aplot.index0=1;
 aplot.nacross=1;
 aplot.ndown=201;
 aplot.nstart=0;
 aplot.nskip=2;
 strcpy(aplot.filename,"output.ps");
 strcpy(aplot.xtitle,"index");
 strcpy(aplot.ytitle,"time");
 strcpy(aplot.bottom,"");
 aplot.type=GREYSCALE;
}





print_aplot()

{
  double tlo,thi;
  int errflag;
  int nrows=my_browser.maxrow;
  int row0=aplot.nstart;
  int col0=aplot.index0;
  int ib,jb,ix,iy;
  if(nrows<=2)return;
  if(aplot.nacross<2||aplot.ndown<2)return;
  jb=row0;
  tlo=0.0;
  thi=20.0;
  if(jb>0&&jb<nrows)tlo=my_browser.data[0][jb];
  jb=row0+aplot.nskip*(aplot.ndown-1);
  if(jb>=nrows)jb=nrows-1;
  if(jb>=0)thi=my_browser.data[0][jb];
 
   errflag=array_print(aplot.filename,aplot.xtitle,aplot.ytitle,aplot.bottom,
                       aplot.nacross,
                       aplot.ndown,col0,row0,aplot.nskip,nrows,my_browser.maxcol,
                      my_browser.data,aplot.zmin,aplot.zmax,tlo,thi,aplot.type);
   if(errflag==-1)err_msg("Couldn't open file");

}















