#include <windows.h>
#include <windowsx.h>
#include <commctrl.h>
#include "structs.h"
#include "misc.h"
#include "mousey.h"
double atof();
#define ROP_OFF R2_NOT
#define ROP_ON R2_NOT
BOOL CALLBACK GetOneStringFunc(HWND,UINT,WPARAM,LPARAM);
BOOL CALLBACK FixPtDialogFunc(HWND,UINT,WPARAM,LPARAM);
BOOL CALLBACK MsgDialogFunc(HWND,UINT,WPARAM,LPARAM);
extern HWND SliderWindow;
extern HWND SliderDismiss,SliderAdd,SliderGo;
extern int SliderExists;

HWND SKHwnd;
char SKString[256];
int SKExist=0;
typedef struct {
    HWND w;
    int flag;
    double x[MAXODE],evr[MAXODE],evm[MAXODE];
} FPINFO;

FPINFO fpinfo;


struct {
         int x0,y0;
         int x1,y1;
         int flag;
}  rubber_info;
struct {
        char title[256],value[256];
        int ok;
} get_string_struct;
extern int NODE;
extern char uvar_names[MAXODE][12];

HWND hProgBar;

LABEL lb[MAXLAB];
GROB grob[MAXGROB];
GRAPH graph[MAXPOP];
CURVE frz[MAXFRZ];
GRAPH *MyGraph;
 extern int DCURXs,DCURYs;
int num_pops;
int current_pop;
/* set_key(float,float); */
mouse_ics(float,float);
mouse_fp(float,float);
many_mouse_ics(float,float);
extern HINSTANCE hInst;
extern HDC gc_graph;
extern HFONT smallfont;
extern HWND cposit,mainwnd,draw_win;

extern SLIDER pslide[MAXSLIDER];

HWND  CreateProgressBar(
     HWND hWnd,     // handle of parent window
     
     UINT iMin,     // minimum value in progress bar range
     UINT iMax,     // maximum value in progress bar range
     UINT iStep,    // step increment for the progress bar
     UINT iPosX,    // x coordinate of left end of progress bar
     UINT iPosY,    // y coordinate of top of progress bar
     UINT iWidth,   // width (length) of progress bar
     UINT iHeight)  // height of progress bar
{
     

    
     hProgBar = CreateWindowEx(
                0,                // no extended style
                PROGRESS_CLASS,   // class name for progress bar
                (LPSTR)NULL,      // no caption (title)
                WS_CHILD |        // window style
                WS_VISIBLE  ,
                iPosX, iPosY,     // position
                iWidth, iHeight,  // width and height
                hWnd,             // parent window
                (HMENU)NULL,      // no menu
                hInst,            // instance
                NULL              // no WM_CREATE parameter
                );

     // set progress bar range
     SendMessage(hProgBar, PBM_SETRANGE, 0, MAKELPARAM(iMin, iMax));
     // set progress bar increment step
     SendMessage(hProgBar, PBM_SETSTEP, (WPARAM)iStep, 0);
 
   /*  SetFocus(hProgBar); */
     return hProgBar;
}
 
  SetProgRange( UINT lo, UINT hi)
  {
     SendMessage(hProgBar, PBM_SETRANGE, 0, MAKELPARAM(lo, hi)); 
      SendMessage(hProgBar, PBM_SETSTEP, (WPARAM)1, 0);
     }
  SetProgPos(UINT i)
  {
       SendMessage(hProgBar, PBM_SETPOS, (WPARAM)i, 0);
  }     
  ResetProgressBar()
  {
     SetProgPos(0); 
  }

  StepProgressBar()
  {
      SendMessage(hProgBar,PBM_STEPIT,0,0);
  }

ping()
 {
   /* MessageBeep(MB_ICONEXCLAMATION); */
 }    

  HWND CreateTrackBar(
     HWND  hWnd,     // handle of parent window
     UINT  iMin,     // minimum value in track bar range
     UINT  iMax,     // maximum value in track bar range
     UINT  iPosX,    // x coordinate of left end of track bar
     UINT  iPosY,    // y coordinate of top of track bar
     UINT  iWidth,   // width of track bar
     UINT  iHeight,  // height of track bar
     DWORD TBS_DIR,  // track bar orientation: TBS_HORZ or TBS_VERT
     DWORD TBS_TICK) // tick mark location: TBS_TOP, TBS_BOTTOM,
                     //           TBS_LEFT, TBS_RIGHT or TBS_BOTH
{
     HWND hTrackBar; // handle for track bar

    

     hTrackBar = CreateWindowEx(
                0,                // no extended style
                TRACKBAR_CLASS,   // class name for track bar
                (LPSTR)NULL,      // no caption (title)
                WS_CHILD |        // window style
                WS_VISIBLE |
                TBS_DIR |         // horizontal or vertical style
                TBS_NOTICKS, // add no tick marks automatically
               
                iPosX, iPosY,     // position
                iWidth, iHeight,  // width and height
                hWnd,             // parent window
                (HMENU)NULL,      // no menu
                hInst,            // instance
                NULL              // no WM_CREATE parameter
                );

     // set track bar range
     SendMessage(hTrackBar, TBM_SETRANGE,
                 (WPARAM)TRUE, MAKELPARAM(iMin, iMax));

     // set track bar page size
     SendMessage(hTrackBar, TBM_SETPAGESIZE, 0, (LPARAM)10);

     // set track bar to center position
     SendMessage(hTrackBar, TBM_SETPOS,
                       (WPARAM)TRUE, (LPARAM)((iMax-iMin)/2));

    
     return hTrackBar;
}

  InitRubber(int cmd,int *type)
  {
      rubber_info.flag=cmd;
      switch(cmd){
          case ZOOM_IN:
          case ZOOM_OUT:
            SelfKill("Click to define zoom region");
            *type=RUBBER_BOX;
            break;
      }
  }
  RubberStuff(HWND w,short x,short y,int type,int flag)
  {
     HDC hdc;
     char bob[256];
     if(w!=draw_win&&flag!=RUBBER_ABORT)return;
   
    if(type!=RUBBER_LINE&&type!=RUBBER_BOX)return;
   
    switch(flag){
        case RUBBER_DOWN:
        /* lprintf(" I get down %d %d\n",x,y); */
            rubber_info.x0=x;
            rubber_info.y0=y;
            rubber_info.x1=x;
            rubber_info.y1=y;
            return;
        case RUBBER_MOVE:
             hdc=GetDC(w);
             RubberDrawIt(hdc,(int)x,(int)y,type,1);
             ReleaseDC(w,hdc);
             return;
       case RUBBER_ABORT:
       x=rubber_info.x1;
       y=rubber_info.y1;
       
             hdc=GetDC(draw_win);
          
                RubberDrawIt(hdc,(int)x,(int)y,type,0);
             ReleaseDC(draw_win,hdc);
             return;
       case RUBBER_UP:
      
             hdc=GetDC(draw_win);
          
                RubberDrawIt(hdc,(int)x,(int)y,type,0);
             ReleaseDC(draw_win,hdc);
        switch(rubber_info.flag){
            case ZOOM_IN:
             zoom_in(rubber_info.x0,rubber_info.y0,
             rubber_info.x1,rubber_info.y1);
             return;
           case ZOOM_OUT:
           zoom_out(rubber_info.x0,rubber_info.y0,
             rubber_info.x1,rubber_info.y1);
             return;
        } 
             return;
    }
  }
  
  RubberDrawIt(HDC hdc,int x,int y,int type, int redraw)
  {
           
            
       switch(type){
                case RUBBER_LINE:
                 SetROP2(hdc,ROP_OFF); 
             MoveToEx(hdc,rubber_info.x0,rubber_info.y0,NULL);
             LineTo(hdc,rubber_info.x1,rubber_info.y1);
             if(redraw){
                  SetROP2(hdc,ROP_ON);
             MoveToEx(hdc,rubber_info.x0,rubber_info.y0,NULL);
             LineTo(hdc,x,y);
             }
             rubber_info.x1=x;
             rubber_info.y1=y;
             
           
 
             return;
             case RUBBER_BOX:
 
               SetROP2(hdc,ROP_OFF); 
               Rectangle(hdc,rubber_info.x0,rubber_info.y0,
               rubber_info.x1,rubber_info.y1);
               if(redraw){
                    SetROP2(hdc,ROP_ON);
                   Rectangle(hdc,rubber_info.x0,rubber_info.y0,
               x,y); }
               rubber_info.x1=x;
             rubber_info.y1=y;
             
             return;
              
    }
  }
  CheckMouseDown(HWND w,short x,short y,int *type)
  {
    char bob[256];
    float xr,yr;
    if(w==draw_win){

    if(*type==RUBBER_BOX||*type==RUBBER_LINE){
        RubberStuff(w,x,y,*type,RUBBER_DOWN);
      
        return ;
    }
   scale_to_real_i(current_pop,x,y,&xr,&yr);
   
     switch(*type){
         case MOUSE_GO:  *type=0;  /* Mouse init conds */
            mouse_ics(xr,yr);
            DeleteSelfKill();
            break;
         case MOUSE_MANY:
              many_mouse_ics(xr,yr); /* repeated mous ics */
            break;  
         case MOUSE_FP:   *type=0;  /* mouse fixed points */
            mouse_fp(xr,yr);
            DeleteSelfKill();
            break;
         case MOUSE_KEY: *type=0;
          MyGraph->legend_x=xr;
          MyGraph->legend_y=yr;
          MyGraph->legend_flag=1;
           DeleteSelfKill();
          
          
           break;
     }
    }
  }    
 


  BOOL HandleParamSlider(HWND w,UINT msg,WPARAM wparam,LPARAM lparam)
  {
      int i,i0;
      int pos;
      HWND wc=(HWND)lparam;
      if(SliderExists==0)return FALSE;
      
      switch(msg){
          case WM_HSCROLL:
               i0=-1;
               for(i=0;i<MAXSLIDER;i++){
                  if(pslide[i].used==1&&wc==pslide[i].tb)i0=i;
               }
               if(i0>-1){ 
                 
                      pos=HIWORD(wparam);
                      set_slide_par(i0,pos);
                   return 1;
               }
               break;
         case WM_COMMAND:
              wc=(HWND)lparam;
               i0=-1;
              
               for(i=0;i<MAXSLIDER;i++)
                  if(pslide[i].used==1&&wc==pslide[i].but)i0=i;
               if(i0>-1){
                   get_par_slide_info(i0);
               return 1;
               }
              if(wc==SliderDismiss){
                  SliderExists=0;
                  DestroyWindow(SliderWindow);
                  return 1;
              }
              
              if(wc==SliderAdd){
                  add_new_slider();
                  return 1;
              }
              if(wc==SliderGo){
                  test_run();
                  return 1;
              }    
                                  
      }
      return 0;
  }       
                    
          
                
  
  
  ArrangePop(int i)
  {
      int w,h;
      int infhgt=25,infwid=200;
      GetWindowDimensions(graph[i].main,&w,&h);
      MoveWindow(graph[i].w,25,2,w-30,h-40,TRUE);
      MoveWindow(graph[i].w_info,(w-200)/2,h-30,infwid,infhgt,TRUE);
      graph[i].Width=w-30;
      graph[i].Height=h-40;
  }
  
 
 ArrangeMainWnd()
  {

     int w,h;
     int wt,ht;
     int shgt=0,swid=180;
     int infhgt=25,infwid=200;
     int prghgt=20,ghgt,yg,xc;
     int i;
     GetWindowDimensions(mainwnd,&w,&h);
     MoveWindow(hProgBar,70,5,w-90,prghgt,TRUE);
    
     MoveWindow(graph[0].w_info,(w-infwid)/2,h-5-infhgt,infwid,infhgt,TRUE);
     ghgt=h-10-infhgt-15-prghgt-shgt-10;
     yg=15+prghgt+shgt+10;
     MoveWindow(graph[0].w,35,yg,w-55,ghgt,TRUE);
     MoveWindow(graph[0].select,0,yg,15,15,TRUE);
     graph[0].Width=w-55;
     graph[0].Height=ghgt;
  }    
          
  GetWindowDimensions(HWND win,int *w,int *h)
  { 
    RECT rect;
    GetClientRect(win,&rect);
    *h=(int)rect.bottom;
    *w=(int)rect.right;
  }
          
 
 ButtonDownStuff(HWND w,SHORT x,SHORT y,int flag)
 {
     char bob[256];
     int i;
     static int xini,yini;
     static double phi,theta;
     int dx,dy;
     float xr,yr;
     if(button_in_lbf(w,x,y))return;
     if(w==MyGraph->w&&MyGraph->ThreeDFlag==1){
     
           
            switch(flag){
                case 0:
                      xini=x;
                      yini=y;
                      phi=MyGraph->Phi;
                      theta=MyGraph->Theta;
                      break;
                case 2:
                     redraw_the_graph();
                      break;
                case 1:
                        dx=x-xini;
                        dy=y-yini;
                        MyGraph->Phi=phi-(double)dy;
                        MyGraph->Theta=theta-(double)dx;
                        redraw_cube(MyGraph->Theta,MyGraph->Phi);
                        
                        
                     
                        break;
            }
         return;   
        }     
     for(i=0;i<MAXPOP;i++){
         
        if(graph[i].Use==1&&w==graph[i].w){
               
        scale_to_real_i(i,x,y,&xr,&yr);
         sprintf(bob,"x=%g,y=%g",xr,yr);
/*         sprintf(graph[i].gr_info,"%s",bob); */
        SetWindowText(graph[i].w_info,bob);
         UpdateWindow(graph[i].w_info);
        
       
                                  
               
     }
     }
 }
 bottom_msg(line,txt)
 int line;
 char *txt;
 {
  SetWindowText(MyGraph->w_info,txt);
  UpdateWindow(MyGraph->w_info);
 }   
 ResizeWindow(HWND w,int cx,int cy)
 {
     int i;


     if(resize_auto(w,cx,cy))return 1;

     if(w==mainwnd){
        ArrangeMainWnd();
        return 1;
     }
     for(i=1;i<num_pops;i++){
         if(graph[i].Use==1&&w==graph[i].main){
             ArrangePop(i);
             return 1;
         }
     }
     return 0;
     

 }


title_text(string)
char *string;
{
 int x,y,len;
      RECT rect;
    if(current_pop==0){
        set_color(0);
         GetClientRect(draw_win,&rect);
        len=DCURXs*strlen(string);
        x=(rect.right-len)/2;
        y=DCURYs;
        
        put_text_x11(x,y,string);
        }
        
    else SetWindowText(MyGraph->main,string);
}


destroy_a_pop(HWND w)
 {
  int i;
  if(w==graph[0].main)
  {
   err_msg("Can't destroy main window");
   return;
  }
  for(i=1;i<MAXPOP;i++)
   if(graph[i].main==w)break;
  if(i>=MAXPOP)return;
   if(graph[i].w==draw_win)toggle_select(0);
  graph[i].Use=0;
  delete_frz(graph[i].w);
  DestroyWindow(graph[i].main);
  num_pops--;
  }

HandleSingMsg(m)
UINT *m;
{
    if(fpinfo.flag==0)return 0;
    return IsDialogMessage(fpinfo.w,m);

}
DeleteSelfKill()
{
     if(SKExist)
     DestroyWindow(SKHwnd);
     SKExist=0;
}     
HandleSelfKill(m)
UINT *m;
{
    if(SKExist==0)return 0;
    return IsDialogMessage(SKHwnd,m);

}

BOOL CALLBACK GetOneStringFunc(HWND hwnd,UINT msg,WPARAM wparam,LPARAM lparam)
{
    switch(msg){
        case WM_INITDIALOG:
          SetWindowText(hwnd,get_string_struct.title);
          SetDlgItemText(hwnd,100,get_string_struct.value);
          return 1;
        case WM_COMMAND:
                 switch(LOWORD(wparam)) {
               case 101:
                 GetDlgItemText(hwnd,100,get_string_struct.value,255);
                 get_string_struct.ok=1;
                 EndDialog(hwnd,0);
                 return 1;
               case 102:
                 get_string_struct.ok=0;
                  EndDialog(hwnd,0);
                 return 1;
                 }
    } 
     return 0;              

    }
get_string(char *title,char *value)
{
    strcpy(get_string_struct.title,title);
    strcpy(get_string_struct.value,value);
    DialogBox(hInst,"GETSTRINGDIALOG",NULL,GetOneStringFunc);
    if(get_string_struct.ok==1){
     strcpy(value,get_string_struct.value);
     return 1;
    }
    return 0;
}

new_int(char *name,int *value)
{
 char bob[256];
   sprintf(bob,"%d",*value);
   if(get_string(name,bob)==1){
       *value=atoi(bob);
       return 1;
   }
   return 0;
}   
new_float(char *name,double *value)
{
   char bob[256];
   sprintf(bob,"%g",*value);
   if(get_string(name,bob)==1){
       *value=atof(bob);
       return 1;
   }
   return 0;
}
BOOL CALLBACK MsgDialogFunc(HWND hwnd,UINT msg,WPARAM wparam,LPARAM lparam)
{
  switch(msg){
        case WM_INITDIALOG:
          SetDlgItemText(hwnd,100,SKString);
          return 1;
        case WM_DESTROY:
          SKExist=0;
          return 1;
  }
  return 0;  
}  
SelfKill(s)
char *s;
{
    if(SKExist){
        DestroyWindow(SKHwnd);
        SKExist=0;
    }
    strcpy(SKString,s);
    SKHwnd=CreateDialog(hInst,"MSGDIALOG",NULL,MsgDialogFunc);
    SKExist=1;
    
}  
create_fixed_point_list(x,evr,evm,rp,rm,cp,cm,im)
double *x,*evr,*evm;
int rp,rm,cp,cm,im;
{
    int i;
    HWND w;
    char bob[256];
    if(fpinfo.flag==0)
    {
      fpinfo.w=CreateDialog(hInst,"FPDIALOG",NULL, FixPtDialogFunc);
      fpinfo.flag=1;
    }
    if(fpinfo.flag==1) /* clear list box */
    {
        SendDlgItemMessage(fpinfo.w,IDFP_FP,LB_RESETCONTENT,0,0L);
        SendDlgItemMessage(fpinfo.w,IDEVAL_FP,LB_RESETCONTENT,0,0L);
    }    
    for(i=0;i<NODE;i++){
        fpinfo.x[i]=x[i];
        fpinfo.evr[i]=evr[i];
        fpinfo.evm[i]=evm[i];
    }
    w=fpinfo.w;
    sprintf(bob,"c+ = %d",cp);
    SetDlgItemText(w,IDCP_FP,bob);
     sprintf(bob,"c-- = %d",cm);
    SetDlgItemText(w,IDCM_FP,bob);
     sprintf(bob,"r+ = %d",rp);
    SetDlgItemText(w,IDRP_FP,bob);
     sprintf(bob,"r-- = %d",rm);
    SetDlgItemText(w,IDRM_FP,bob);
     sprintf(bob,"im = %d",im);
    SetDlgItemText(w,IDIM_FP,bob);
    if(cp>0||rp>0)
     SetDlgItemText(w,IDSTAB_FP,"UNSTABLE");
     else
     SetDlgItemText(w,IDSTAB_FP,"STABLE");
   for(i=0;i<NODE;i++){
       sprintf(bob,"%s=%g",uvar_names[i],fpinfo.x[i]);
       SendDlgItemMessage(w,IDFP_FP,LB_ADDSTRING,0,(LPARAM)bob);
       if(evm[i]<0.0)
          sprintf(bob,"%g - I %g",evr[i],-evm[i]);
       if(evm[i]>0.0)   
           sprintf(bob,"%g + I %g",evr[i],evm[i]);
       if(evm[i]==0.0)
            sprintf(bob,"%g",evr[i]);
        SendDlgItemMessage(w,IDEVAL_FP,LB_ADDSTRING,0,(LPARAM)bob);
   }  
     
    
    
        
}


BOOL CALLBACK FixPtDialogFunc(HWND hwnd,UINT msg,WPARAM wparam,LPARAM lparam)
{
     int i;
    switch(msg){
        case WM_INITDIALOG:
          return 1;
        case WM_COMMAND:
           switch(LOWORD(wparam)) {
               case IDOK_FP:
                  DestroyWindow(hwnd);
                  fpinfo.flag=0;
                  return 1;
               case IDGRAB_FP:
                  get_ic(0,fpinfo.x);
                  redraw_ics();
                  return 1;
           }
    }
    return 0;
}
                    
    
create_a_pop()
 {
  int i,index;
  HWND ww;
  for(i=1;i<MAXPOP;i++)
  if(graph[i].Use==0)break;
  if(i>=MAXPOP)
  {
   MessageBox(NULL,"Too many graph windows",NULL,MB_OK);
   return;
  }
   index=i;
   
   ww=CreateWindow("GRAPH","My pop",WS_POPUP|WS_OVERLAPPEDWINDOW,CW_USEDEFAULT,CW_USEDEFAULT,
      250,250,NULL,NULL,hInst,NULL);
   graph[index].main=ww;
   ShowWindow(ww,SW_SHOWDEFAULT);
   graph[index].w=CreateWindow("POP",NULL,WS_CHILD|WS_BORDER,2,2,246,210,
                    ww,NULL,hInst,NULL);
    ShowWindow(graph[index].w,SW_SHOWDEFAULT);                        
 graph[index].w_info=CreateWindow("static",NULL,
      WS_CHILD|WS_BORDER|SS_CENTER,25,220,200,25,ww,NULL,hInst,NULL);
  ShowWindow(graph[index].w_info,SW_SHOWDEFAULT);
  graph[index].select=CreateWindow("button",NULL,WS_CHILD|BS_CHECKBOX,0,0,15,15,graph[index].main,
                 NULL,hInst,NULL);
 ShowWindow(graph[index].select,SW_SHOWDEFAULT);
   copy_graph(index,current_pop); 
  graph[index].Width=246;
  graph[index].Height=210;
  graph[index].x0=0;
  graph[index].y0=0;
  graph[index].Use=1;
  ArrangePop(index);
  num_pops++;
  toggle_select(index);
 /*  select_window(graph[index].w); */
 
}

toggle_pop(HWND w)
{
    int i;
     char bob[256];
    for(i=0;i<MAXPOP;i++){
        
           if(graph[i].Use&&(w==graph[i].select)){
                toggle_select(i);
                return 1;
           }
    }
    return 0;
}           
               

               
toggle_select(i)
int i;
{
    int j;
    for(j=0;j<MAXPOP;j++)
        if(graph[j].Use)SendMessage(graph[j].select,BM_SETCHECK,0,0);
    SendMessage(graph[i].select,BM_SETCHECK,1,0);
    draw_win=graph[i].w;
    current_pop=i;
    MyGraph=&graph[current_pop];
    /* test_graphs(); */
}
        
init_grafs(x,y,w,h)
int x,y,w,h;
{
 int i;
 lprintf("In commctl name=%s \n",uvar_names[0]);
 for(i=0;i<MAXLAB;i++)
 {
  lb[i].use=0;
  lb[i].w=(Window)0;
 } 
 for(i=0;i<MAXGROB;i++){
   grob[i].w=(Window)0;
   grob[i].use=0;
 }
 /* init_bd();  */
 for(i=0;i<MAXFRZ;i++)
   frz[i].use=0;
 /* for(i=0;i<MAXNCLINE ... */
 for(i=0;i<MAXPOP;i++)
 graph[i].Use=0;
 init_all_graph();
  graph[0].main=mainwnd;
  graph[0].w=CreateWindow("POP",NULL,WS_CHILD|WS_BORDER,x,y,w,h,mainwnd,NULL,hInst,NULL);
  ShowWindow(graph[0].w,SW_SHOWDEFAULT);               
 graph[0].w_info=CreateWindow("static",NULL,SS_CENTER|WS_CHILD|WS_BORDER,
                 x,y+h+5,200,40,mainwnd,NULL,hInst,NULL);
 ShowWindow(graph[0].w_info,SW_SHOWDEFAULT);
 graph[0].select=CreateWindow("button",NULL,WS_CHILD|BS_CHECKBOX,0,0,20,20,graph[0].main,
                 NULL,hInst,NULL);
 ShowWindow(graph[0].select,SW_SHOWDEFAULT);
                 
 draw_win=graph[0].w;
 graph[0].Use=1;
 graph[0].Restore=1;
 graph[0].Nullrestore=1;
 graph[0].x0=x;
 graph[0].y0=y;
 graph[0].Height=h;
 graph[0].Width=w;
 
 num_pops=1;
 
 current_pop=0;
  /* get_draw_area(); */
  toggle_select(0);
 /* select_sym(graph[0].w); */
 
}

expose_pop(w)
{
  int i;
  int cp=current_pop;
  for(i=0;i<MAXPOP;i++){
    if((graph[i].Use)&&(w==graph[i].w)){
       current_pop=i;
       MyGraph=&graph[i];
                draw_win=graph[i].w;
                get_draw_area();
                redraw();
                draw_freeze(w);
                restore_nullclines();
                
               
                
}
}
     current_pop=cp;
     draw_win=graph[cp].w;
     MyGraph=&graph[cp];
     get_draw_area();
     
}
