/*   Defines for numerics dialog   */


extern double DELTA_T,TEND,T0,TRANS,NULL_ERR,EVEC_ERR,NEWT_ERR;
extern double BOUND,DELAY,TOLER,HMIN,HMAX,ATOLER;
extern float *fft_data,*hist_data,color_scale,min_scale;
extern double POIPLN;

extern int NMESH,NJMP,METHOD,color_flag,NC_ITER;
extern int EVEC_ITER,FOREVER;

extern int POIMAP,POIVAR,POISGN,SOS;

extern int BVP_MAXIT,DelayGrid;

extern double AlphaMax,OmegaMax,NEWT_ERR,EVEC_ERR,
BVP_TOL,BVP_EPS;

extern int HIST,HVAR,hist_ind;

extern int XSHFT,YSHFT,ZSHFT;

extern int NKernel,MaxPoints,AutoEvaluate;
extern int INFLAG,MyStart,NDELAYS;

extern int DF_GRID,FLOW_GRID;
rung_kut();
bak_euler();
discrete();
euler();
mod_euler();
adams();
volterra();
extern (*solver)();
#define VOLTERRA 10 
#define BACKEUL 6
#define RKQS 8
#define STIFF 7
#define GEAR 5
#define CVODE 9

#define IDNUM_METHOD 1000
#define IDNUM_DISCRETE 1001
#define IDNUM_EULER 1002
#define IDNUM_HEUN 1003
#define IDNUM_RK4 1004
#define IDNUM_ADAMS 1005
#define IDNUM_GEAR 1006
#define IDNUM_BKEUL 1007
#define IDNUM_STIFF 1008
#define IDNUM_QUALRK 1009
#define IDNUM_CVODE 1010
#define IDNUM_VOLTERRA 1011

#define IDNUM_METHCAN 1012
#define IDNUM_METHOK 1013
#define IDNUM_METHTOL 1014
#define IDNUM_METHMAX 1015
#define IDNUM_METHMIN 1016
#define IDNUM_METHATOL 1017
#define IDNUM_BOUNDS  1018

#define IDNUM_TIMT0 1020
#define IDNUM_TIMTEND 1021
#define IDNUM_TIMDT 1022
#define IDNUM_TIMNOUT 1023
#define IDNUM_TIMTRANS 1024
#define IDNUM_TIMDEL 1025
#define IDNUM_TIMOK 1026

#define IDNULL_PP 1300
#define IDDIR_PP 1301
#define IDFLOW_PP 1302
#define IDOK_PP 1304

#define IDMAX_COL 1310
#define IDMIN_COL 1311
#define IDUSER_COL 1312
#define IDVEL_COL 1313
#define IDOFF_COL 1314
#define IDUSE_COL 1315
#define IDSCALE_COL 1316
#define IDOK_COL 1317

#define IDOK_PMAP 130
#define IDCANCEL_PMAP 132

#define IDPOS_PMAP 105
#define IDNEG_PMAP 107
#define IDBOT_PMAP 108

#define IDNON_PMAP 114
#define IDSEC_PMAP 116
#define IDMAX_PMAP 117
#define IDPER_PMAP 126

#define IDSOS_PMAP 122

#define IDVAR_PMAP 128
#define IDVAL_PMAP 101

#define IDX_RUE 101
#define IDY_RUE 105
#define IDZ_RUE 107
#define IDOK_RUE 110
#define IDRESET_RUE 108

/* range ics */

#define IDVARY_RI 102
#define IDFROM_RI 106
#define IDTO_RI 108
#define IDSTEPS_RI 112
#define IDOLDIC_RI 113
#define IDRESET_RI 115
#define IDCANCEL_RI 138
#define IDCYCLE_RI 101
#define IDOKAY_RI 140


#define IDARRAY_R2 100
#define IDCURVE_R2 101
#define IDVARY1_R2 102
#define IDVARY2_R2 105
#define IDFROM1_R2 103
#define IDTO1_R2 104
#define IDFROM2_R2 106
#define IDTO2_R2 107
#define IDSTEPS_R2 108
#define IDCYCLE_R2 109
#define IDRESET_R2 111
#define IDOLDIC_R2 110

#define IDVARY_BV 100
#define IDFROM_BV 101
#define IDTO_BV 102
#define IDSTEPS_BV 103
#define IDLEFT_BV 104
#define IDRIGHT_BV 105
#define IDCYCLE_BV 106


/* fprange */
#define IDVARY_RF 102
#define IDFROM_RF 106
#define IDTO_RF 108
#define IDSTEPS_RF 112
#define IDSHOOT_RF 113
#define IDSTAB_RF 115
#define IDCANCEL_RF 138
#define IDOKAY_RF 140

/* numctl */
#define ID_BVPITER 200
#define ID_BVPEPS 201
#define ID_BVPTOL 202
#define ID_NEWTIT 203
#define ID_NEWDH 204
#define ID_NEWTOL 205
#define ID_ALPH 206
#define ID_OMEG 207
#define ID_DELIT 208
#define ID_OK_NC 100
#define ID_CAN_NC 102

#define IDFOUR_NMODES 100
#define IDFOUR_VAR 101

#define IDHIST_BINS 101
#define IDHIST_VAR 100
#define IDHIST_COND 102
#define IDHIST_ZLO 103
#define IDHIST_ZHI 104 





